#!/usr/bin/env python

# usage: oscp-remote.py <HOST> <PORT>
# simple remote interface to oscp player by ariel/KotCzarny

import sys; import time
import os
import math
from os.path import expanduser
import random

import pygtk; pygtk.require('2.0'); import gtk; import socket; import gobject
import pango;

class oscp_remote:
 #
 # configuration was moved to ~/.oscp-remote.conf
 # if no conf, it will be created on first start
 #

 HOST="127.0.0.1"; PORT=44322; config_ver=0; config_trig=0;
 defsize=0; style_me=0; iconset=0; ww=0; wh=0; dpi=0; id=""; ss=0.0; oscp_bin=""
 i_like_buttons=0; LISTTYPE=0; fullscreen=0; small=0; volume_as_slider=0;
 pixpa="/opt/oscp/share/images/" # pixmap path
 lastperc=-1; lmax=0; lcur=0; cur=0; hdb=""; cfail=1; curname=""; listname="";
 state=0; time=0; ttime=0; vol=0; last_mrl_filt=""
 focus=0; favRstate=0; ww=0; wh=0; last_time=-1; curtype=0; keep_awake_trig=0; corev="disconnected."
 i_title=""; i_artist=""; i_album=""; i_year=""; i_genre=""; i_comment=""; i_chan=0;
 i_shu=0; i_rep=0;
 skind=expanduser("~")+"/.oscp/skin/"; skins_lastdir=""; current_skin=""
 ww=ww=wx=wy=0;
 eq_tog_ign=0; eq=0; eq_max=12; eq_min=-eq_max; eq60=0.0; eq170=0.0; eq310=0.0; eq600=0.0;
 eq1k=0.0; eq3k=0.0; eq6k=0.0; eq12k=0.0; eq14k=0.0; eq16k=0.0; eq22k=0.0
 eff_tog_ign=0; eff=0

 def handle_dbus(self, signal, button): print "handle_dbus: "+str(signal)+","+str(button)

 def handle_hsb(self, signal, button):
  #print "handle_hsb: "+str(signal)+","+str(button)
  #if(button=="phone"): self.playpause(None,None);
  if(button=="phone"): self.next(None,None);
  elif(button=="next-song"): self.next(None,None);
  elif(button=="previous-song"): self.prev(None,None);
  elif(button=="play-cd"): self.playpause(None,None);

 def handle_focus(self, signal, button):
  #print "handle_dbus: "+str(signal)+","+str(button)
  if(self.focus==0): self.focus=time.time()
  else:
   dt=time.time()-self.focus; self.focus=0
   if(dt<0.5): self.ffwd(None,None)
   else: self.playpause(None,None)

 def init_style(self):
  if(self.style_me==0): self.local_gtkrc=""
#######//pc styled lite//#######
  elif(self.id=='pc'):
   if(self.style_me==1): self.local_gtkrc="""  style "default"
{ GtkCheckButton::indicator-size=9  #GtkPaned::handle-size=6  #GtkWidget::interior-focus=0
 GtkRange::trough-border=0  GtkRange::slider-width=12  GtkRange::stepper-size=15
 GtkRange::stepper-spacing=0  GtkRange::trough-side-details=0  GtkRange::slider-width=24
 GtkWidget::focus-line-width=0  GtkWidget::focus-padding=0  xthickness=0  ythickness=0

 GtkEntry::cursor_color="#fd0"  GtkTextView::cursor_color="#fd0"
fg[NORMAL]="#eee" fg[ACTIVE]="#ddd" fg[INSENSITIVE]="#000" fg[PRELIGHT]="#eee" fg[SELECTED]="#eee"
bg[NORMAL]="#666" bg[ACTIVE]="#555" bg[INSENSITIVE]="#555" bg[PRELIGHT]="#777" bg[SELECTED]="#444"
base[NORMAL]="#333" base[ACTIVE]="#666" base[INSENSITIVE]="#666" base[PRELIGHT]="#777" base[SELECTED]="#666" 
text[NORMAL]="#eee" text[ACTIVE]="#000" text[INSENSITIVE]="#777" text[PRELIGHT]="#000" text[SELECTED]="#eee"

# ls /usr/lib/gtk-2.0/2.*/engines/*.so
# clearlooks glide industrial pixmap smooth crux-engine hcengine mist redmond95 thinice
engine "thinice" { }
#engine "crux-engine" { }
}  class "GtkWidget" style "default" """

######//pc styled//#######
   elif(self.style_me==2):
    #print "pc2"
    if(self.ww<=0 or self.wh<=0): self.ww=275*2; self.wh=116*2;
    self.local_gtkrc=""" pixmap_path "/opt/oscp/share/images"
style "default"
{ GtkWidget::focus-line-width=0  GtkWidget::focus-padding=0  xthickness=0  ythickness=0
 GtkEntry::cursor_color="#fd0"  GtkTextView::cursor_color="#fd0"
fg[NORMAL]="#eee" fg[ACTIVE]="#ddd" fg[INSENSITIVE]="#000" fg[PRELIGHT]="#eee" fg[SELECTED]="#eee"
bg[NORMAL]="#111" bg[ACTIVE]="#555" bg[INSENSITIVE]="#555" bg[PRELIGHT]="#777" bg[SELECTED]="#444"
base[NORMAL]="#333" base[ACTIVE]="#666" base[INSENSITIVE]="#666" base[PRELIGHT]="#777" base[SELECTED]="#666" 
text[NORMAL]="#eee" text[ACTIVE]="#000" text[INSENSITIVE]="#777" text[PRELIGHT]="#000" text[SELECTED]="#eee"
}
style "pixmap" { fg[NORMAL]="#eee" fg[PRELIGHT]="#eee"  engine "pixmap" {
  image { function=BOX state=ACTIVE file="a-blank.png" }
  image { function=BOX file="blank.png" }
}}
style "pixmap_wide" { fg[NORMAL]="#eee" fg[PRELIGHT]="#eee" ythickness=1 xthickness=1
 GtkProgressBar::min-horizontal-bar-height=24  engine "pixmap" {
  image { function=BOX state=PRELIGHT file="a-blank-wide.png" }
  image { function=BOX file="blank-wide.png" }
}}
class "GtkWidget" style "default"
class "GtkButton" style "pixmap"
class "GtkProgressBar" style "pixmap_wide"
"""
######//pc styled (winamp skin)//#######
   elif(self.style_me==3 or self.style_me==2):
    #print "pc3"
#    gtk.stock_add([('i_prev',"",0,0,"")])
    if(self.style_me==3): self.ww=275*2; self.wh=116*2;
    self.local_gtkrc=""" pixmap_path "/opt/oscp/share/images"

style "default"
{
 GtkWidget::focus-line-width=0 GtkWidget::focus-padding=0  xthickness=0  ythickness=0
 GtkEntry::cursor_color="#fd0"  GtkTextView::cursor_color="#fd0"
fg[NORMAL]="#eee" fg[ACTIVE]="#ddd" fg[INSENSITIVE]="#000" fg[PRELIGHT]="#eee" fg[SELECTED]="#eee"
bg[NORMAL]="#111" bg[ACTIVE]="#555" bg[INSENSITIVE]="#555" bg[PRELIGHT]="#777" bg[SELECTED]="#444"
base[NORMAL]="#333" base[ACTIVE]="#666" base[INSENSITIVE]="#666" base[PRELIGHT]="#777" base[SELECTED]="#666" 
text[NORMAL]="#eee" text[ACTIVE]="#000" text[INSENSITIVE]="#777" text[PRELIGHT]="#000" text[SELECTED]="#eee"
}
style "pixmap" { fg[NORMAL]="#eee" fg[PRELIGHT]="#eee" engine "pixmap" {
  image { function=BOX state=ACTIVE file="a-blank.png" }
  image { function=BOX file="blank.png" }
}}
style "pixmap_wide" {
 GtkProgressBar::min-horizontal-bar-height=24
 GtkProgressBar::min-vertical-bar-width=24
 ythickness=1 xthickness=1

 fg[NORMAL]="#eee" fg[PRELIGHT]="#eee" engine "pixmap" {
  image { function=BOX state=PRELIGHT file="a-blank-wide.png" }
  image { function=BOX file="blank-wide.png" }
}}
#class "GtkButton" style "pixmap"
#class "GtkButton" style "default"
class "GtkProgressBar" style "pixmap_wide"
class "GtkWidget" style "default"
"""
###########//n900 styled//##########
  elif(self.id=='n900' or self.id=='n8x0'):
######//pc styled (winamp skin)//#######
   if(self.style_me==4):
    self.ww=275*2; self.wh=116*2;
    self.local_gtkrc=""" pixmap_path "/opt/oscp/share/images"
style "default"
{ GtkWidget::focus-line-width=0 GtkWidget::focus-padding=0  xthickness=0  ythickness=0
fg[NORMAL]="#eee" fg[ACTIVE]="#ddd" fg[INSENSITIVE]="#000" fg[PRELIGHT]="#eee" fg[SELECTED]="#eee"
bg[NORMAL]="#111" bg[ACTIVE]="#555" bg[INSENSITIVE]="#555" bg[PRELIGHT]="#777" bg[SELECTED]="#444"
base[NORMAL]="#333" base[ACTIVE]="#666" base[INSENSITIVE]="#666" base[PRELIGHT]="#777" base[SELECTED]="#666" 
text[NORMAL]="#eee" text[ACTIVE]="#000" text[INSENSITIVE]="#777" text[PRELIGHT]="#000" text[SELECTED]="#eee"
}
class "GtkWidget" style "default"
"""
   elif(self.style_me==1): self.local_gtkrc=""" pixmap_path "/opt/oscp/share/images" """
######## default ########
   else: self.local_gtkrc=""" pixmap_path "/opt/oscp/share/images"
style "default"
{ xthickness=0  ythickness=0
# GtkWidget::interior-focus=0 GtkWidget::focus-line-width=0  GtkWidget::focus-padding=0 
# GtkRange::slider-width=44 GtkRange::stepper-spacing=0 GtkRange::trough-side-details=0
}
style "pixmap" { fg[NORMAL]="#eee" fg[PRELIGHT]="#eee"
 engine "pixmap" {
  image { function=BOX state=ACTIVE file="a-blank.png" }
  image { function=BOX file="blank.png" }
}}
style "pixmap_wide" { fg[NORMAL]="#eee" fg[PRELIGHT]="#eee" ythickness=1 xthickness=1
 engine "pixmap" {
  image { function=BOX state=PRELIGHT file="a-blank-wide.png" }
  image { function=BOX file="blank-wide.png" }
}}
style "default-colors" {
 color["fgN"]="#eee"
 color["bgN"]="#111"
 color["fgA"]=@bgN color["fgI"]=@fgN color["fgP"]=@fgN color["fgS"]=@bgN
 color["bgA"]=@fgN color["bgI"]=@bgN color["bgP"]=@bgN color["bgS"]=@fgN
 color["teN"]=@fgN color["teA"]=@fgA color["teI"]=@fgI color["teP"]=@fgP color["teS"]=@fgS
 color["baN"]=@bgN color["baA"]=@bgA color["baI"]=@bgI color["baP"]=@bgP color["baS"]=@bgS

 fg[NORMAL]=@fgN fg[ACTIVE]=@fgA fg[INSENSITIVE]=@fgI fg[PRELIGHT]=@fgP fg[SELECTED]=@fgS
 bg[NORMAL]=@bgN bg[ACTIVE]=@bgA bg[INSENSITIVE]=@bgI bg[PRELIGHT]=@bgP bg[SELECTED]=@bgS
 text[NORMAL]=@teN text[ACTIVE]=@teA text[INSENSITIVE]=@teI text[PRELIGHT]=@teP text[SELECTED]=@teS
 base[NORMAL]=@baN base[ACTIVE]=@baA base[INSENSITIVE]=@baI base[PRELIGHT]=@baP base[SELECTED]=@baS
}
style "default-colors-2" {
 fg[NORMAL]="#777" text[NORMAL]="#777"
# fg[NORMAL]="#1f1" text[NORMAL]="#771" bg[NORMAL]="#f00" base[NORMAL]="#0dd" bg_pixmap[NORMAL]=""
# fg[ACTIVE]="#1f1" text[ACTIVE]="#771" bg[ACTIVE]="#f00" base[ACTIVE]="#0dd" bg_pixmap[ACTIVE]=""
# fg[INSENSITIVE]="#1f1" text[INSENSITIVE]="#771" bg[INSENSITIVE]="#f00" base[INSENSITIVE]="#0dd" bg_pixmap[INSENSITIVE]=""
# fg[PRELIGHT]="#1f1" text[PRELIGHT]="#771" bg[PRELIGHT]="#f00" base[PRELIGHT]="#0dd" bg_pixmap[PRELIGHT]=""
# fg[SELECTED]="#1f1" text[SELECTED]="#771" bg[SELECTED]="#f00" base[SELECTED]="#0dd" bg_pixmap[SELECTED]=""
}
class "GtkWidget" style : highest "default"
class "GtkWidget" style : highest "default-colors"
class "GtkButton" style : highest "pixmap"
class "GtkProgressBar" style : highest "pixmap_wide"
class "GtkEntry" style : highest "default-colors-2"
"""
#######//system style//##########
  else: self.local_gtkrc=""

 l00="";l01="";l02="";l03="";l04="";l05="";l06="";l07="";l08="";l09="";
 l10="";l11="";l12="";l13="";l14="";l15="";l16="";l17="";l18="";l19="";
 l20="";l21="";l22="";l23="";l24="";l25="";l26="";l27="";l28="";l29="";
 l30="";l31="";l32="";l33="";l34="";l35="";l36="";l37="";l38="";l39="";

 def state2label(self, s):
  if(s==0): return self.l2+self.l1 #uninited (no slave)
  elif(s==1): return self.l1+self.l2 #slave forked
  elif(s==2): return self.l16 #alive(stopped)
  elif(s==3): return self.l15 #playing
  elif(s==4): return self.l12 #paused
  elif(s==5): return self.l2+self.l3 #loading(send load request to slave)
  elif(s==6): return self.l3+self.l2 #loading2(slave reacted to load request)
  elif(s==12): return self.l2+self.l1 #alive(stopping)
  elif(s==14): return self.l2+self.l0 #pausing
  else: return "??"


 def help_destroy(self, widget, data=None): self.whelp.destroy()
 def help(self, widget, data=None):
  if(self.id=="n900" or self.id=="n8x0"):
   w=gtk.Window(gtk.WINDOW_POPUP); w.set_size_request(800,480); w.fullscreen()
  else: w=gtk.Window(gtk.WINDOW_TOPLEVEL); w.set_size_request(600,500)
  w.set_title("oscp - quick help"); w.set_border_width(10);

  box1=gtk.HBox(0, 0); w.add(box1); box1.show()
  te0=gtk.Label(); te0.set_line_wrap(1); te0.set_selectable(1); te0.set_text(""); te0.show();
#  te.set_editable(0); te.realize() te.freeze(); te.insert(None, None, None, "123"); te.thaw()
  bb=gtk.VBox(0, 0); bb.show()
  te1=gtk.Label(); te1.set_line_wrap(1); te1.set_selectable(1); te1.set_text(\
"""\noscp-remote.py - network remote/local gui for oscp (multiplatform player for (almost) any a/v format and network streams)

first time help:
 - this is only gui, you need working core (local or remote)
 - to spawn local core (the one that actually plays music) press 'gears' icon
 - to connect to already spawned core press 'computers' icon and enter host:port
 - when core is in STOPPED or PAUSED state it uses almost no resources, so no need to kill/spawn it everytime (also, pulseaudio should die in a fire)
 - there is no separate 'media library', your directories/files are your 'media library'
 - to create recursive list from current directory press ';' or mrl button under 'm'
 - to memorize current path press 'm' then number
 - to go to memorized path just press the number
 - to look for paths/files press 'l'. uses fnmatch:
   ? - match any char (exactly one), * match any char group (including none)
   [a-z3-5] - match char list
 - you can open .zip files as if they were directories
 - V/S/R buttons are: Vids/Shuffle/Repeat
 - LOVE button favourites track on last.fm (only when scrobbling is enabled)
 - videos on n900 play through gstreamer, on other configs require mplayer binary in path
 - info screen contains: 'help', 'options', 'toggle winamp skin mode' (the paintbrush)
 - if you want headphone detection edit ~/.oscp.conf and set dev_type=n900 and hponly=1

use cases:
 1/ local player: spawn core, then control via remote (you can close remote without killing core)
 2/ remote controller: start core on n8x0/n900/pc connected to hifi or tv then control from another device

main window buttons:
"""); te1.show();
  im1=gtk.Image(); im1.set_from_file(self.pixpa+"oscp-remote-main-window.png"); im1.show();

  te2=gtk.Label(); te2.set_line_wrap(1); te2.set_selectable(1); te2.set_text(\
"""

more information:
 - http://talk.maemo.org/showthread.php?t=94590
 - https://sourceforge.net/projects/oscp/

supported formats:
 - libav (mp3, wav, ogg, aac, mpc, wma, flac, ape, flv, avi, wmv, rm, etc)
 - xmp (mod, med, xm, s3m, it, dbm, psm, omx, okt, digi, 669, mtm, acid, umx)
 - wildmidi (mid, rmi, xmi, hmi, hmp)
 - gme (ay, gbs, gym, hes, kss, nsf, nsfe, sap, spc, vgm)
 - sidplay2 (sid, psid)
 - mdxplay (mdx)
 - fc14dec (fc, fc13, fc14)
 - sc68 (sc68, sndh)
 - asapconv (sap, cmc, cm3, cmr, cms, dmc, dlt, mpt, mpd, rmt, tmc, tm8, tm2)
 - uade2 (fc, bp, ay, dl, tfmx, hip, mon, sa, ahx, aon, cust, and many more..)
 - mplayer (many, depends on build)

feats:
 - small and fast, remembers playlist position, unzip/unrar support
 - plays network streams (http://, mms://)
 - playlists, favourites, one-key recursive playlists
 - ncurses ui with easy navigation, lirc (remote) support
 - tcp server for remote control

oscp-remote.py default keybindings:
 quit: 'q' or ESC
 media info: 'i'
 playlist window: 'w'
 equalizer window: 'e'
 left(go parent): LEFT
 right(play file/enter dir): RIGHT
 up/down/pgup/pgdown/home/end: navigate list
 prev: '['
 next: ']' or SPACE
 rwnd: ','
 ffwd: '.'
 pause: 'p'
 stop: '\\'
 vol-: '-' or '_'
 vol+: '+' or '='
 make_recursive_list: ';'
 connect to core: 'c'
 shutdown core: 'x'
 select fav: [0-9]
 memorize fav: 'm' then [0-9]
n8x0/n900:
 prev/next: hw-/hw+
"""); te2.show();
  bb.pack_start(te1,0,0);
  bb.pack_start(im1,0,0);
  bb.pack_start(te2,0,0);

  sw = gtk.ScrolledWindow(); sw.add_with_viewport(bb);
  sw.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC); sw.show()

  box2=gtk.VBox(0,0); box2.show();
  b1=self.nb("[x]", "ok"); b1.show(); b1.connect("clicked", self.help_destroy)

  box2.pack_start(b1, 0, 0, 10)
  box2.pack_start(te0, 0, 0, 0)

  box1.pack_start(box2, 0, 0, 10)
  box1.pack_start(sw, 1, 1, 10)

  b1.set_flags(gtk.CAN_DEFAULT); b1.grab_default(); w.show(); self.whelp=w

  try: self.info_destroy(None, None)
  except: pass

 def info_destroy(self, widget, data=None): self.winfo.destroy()
 def info(self, widget, data=None):
  if(self.id=="n900" or self.id=="n8x0"):
   w=gtk.Window(gtk.WINDOW_POPUP); w.set_size_request(800,480); w.fullscreen()
  else: w=gtk.Window(gtk.WINDOW_TOPLEVEL); w.set_size_request(600,500)
  w.set_title("oscp - media info");
  w.set_border_width(10);

  box1=gtk.HBox(0, 0); w.add(box1); box1.show()
  te0=gtk.Label(); te0.set_line_wrap(1); te0.set_selectable(1); te0.set_text(""); te0.show();
  te=gtk.Label(); te.set_line_wrap(1); te.set_selectable(1); te.set_text(\
"\ncore addr: "+self.HOST+":"+str(self.PORT)
+"\ncore ver: "+self.corev\
+"\n"\
+"\nlistsize: "+str(self.lmax)+", listname: "+self.listname\
+"\ncur: "+str(self.cur)+", curname: "+self.curname\
+"\n"\
+"\nduration: "+self.l_ttime.get_text()\
+"\nfreq: "+self.l_freq.get_text()\
+", chans: "+self.l_chan.get_text()\
+", bitrate: "+self.l_bitrate.get_text()\
+"\n"\
+"\ntitle: "+self.i_title\
+"\nartist: "+self.i_artist\
+"\nalbum: "+self.i_album\
+"\nyear: "+self.i_year\
+"\ngenre: "+self.i_genre\
+"\ncomment: "+self.i_comment\
); te.show();

  sw = gtk.ScrolledWindow(); sw.add_with_viewport(te); sw.show()
  sw.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)

  box2=gtk.VBox(0,0); box2.show();
  b1=self.nb("[x]", "ok"); b1.show(); b1.connect("clicked", self.info_destroy)
  b2=self.nb("[i]", "help"); b2.show(); b2.connect("clicked", self.help)
  b4=self.nb("[o]", "opts"); b4.show(); b4.connect("clicked", self.opts)
  b3=self.nb("[TS]","chstyle"); b3.show(); b3.connect("clicked", self.toggle_style)

  box2.pack_start(te0, 0, 0, 10)
  box2.pack_start(b1, 0, 0, 10)
  box2.pack_start(b2, 0, 0, 10)
  box2.pack_start(b4, 0, 0, 10)
  box2.pack_start(b3, 0, 0, 10)
  box1.pack_start(box2, 0, 0, 10)
  box1.pack_start(sw, 1, 1, 10)

  b1.set_flags(gtk.CAN_DEFAULT); b1.grab_default(); w.show(); self.winfo=w


#ton.spin(direction, increment)
#
#The direction parameter can take one of the following values:
#
#  SPIN_STEP_FORWARD
#  SPIN_STEP_BACKWARD
#  SPIN_PAGE_FORWARD
#  SPIN_PAGE_BACKWARD
#  SPIN_HOME
#  SPIN_END
#  SPIN_USER_DEFINED
 def spinme(self, widget, sp, ch):
  if(ch>0): sp.spin(gtk.SPIN_STEP_FORWARD, 1)
  if(ch<0): sp.spin(gtk.SPIN_STEP_BACKWARD, 1)

 def opts_destroy(self, widget, data=None): self.wopts.destroy()
 def opts_apply(self, widget, cb1, cb2, cb3, tb1, tb2, tb3, sp1):
  restart=0

  i1=[1, 0, -1, -3, -4, -5]; i=i1[cb1.get_active()]
  if(i!=self.iconset): self.iconset=i; restart=1
  i1=[0, 1, 2]; i=i1[cb2.get_active()]
  if(i!=self.LISTTYPE): self.LISTTYPE=i; restart=1
  i1=[0, 1, 2, 3]; i=i1[cb3.get_active()]
  if(i!=self.style_me): self.style_me=i; restart=1

  i=tb1.get_active(); i2=self.volume_as_slider
  if((i and i2==0) or (not(i) and i2!=0)): self.volume_as_slider=1-self.volume_as_slider; restart=1
  i=tb2.get_active(); i2=self.i_like_buttons
  if((i and i2==0) or (not(i) and i2!=0)): self.favSH(1)
  i=tb3.get_active(); i2=self.fullscreen
  if((i and i2==0) or (not(i) and i2!=0)): self.toggle_fs(1)

  i=sp1.get_value_as_int()
  if(i!=self.defsize): self.defsize=i; restart=1

  self.opts_destroy(None, None)
  if(restart): self.save_conf(); exe=sys.executable; os.execl(exe, exe, * sys.argv)

 def test3(self, a, b, c): print "a: "+str(a); print "b: "+str(b); print "c: "+str(c)
 def test2(self, a, b): print "a: "+str(a); print "b: "+str(b)
 def test1(self, a): print "a: "+str(a)

 def opts(self, widget, data=None):
  if(self.id=="n900" or self.id=="n8x0"):
   w=gtk.Window(gtk.WINDOW_POPUP); w.set_size_request(800,480); w.fullscreen()
  else: w=gtk.Window(gtk.WINDOW_TOPLEVEL); w.set_size_request(600,500)
  w.set_title("oscp - media info");
  w.set_border_width(10);

  box1=gtk.HBox(0, 0); w.add(box1); box1.show()
  te0=gtk.Label(); te0.set_line_wrap(1); te0.set_selectable(1); te0.set_text(""); te0.show();
  te=gtk.Label(); te.set_line_wrap(1); te.set_selectable(1); te.set_text(\
"oscp - options"\
); te.show();

  box3=gtk.VBox(0,0); box3.show();
  box3.pack_start(te, 0, 0, 10)

  sp="      "
  cb1=gtk.combo_box_new_text()
  cb1.append_text(sp+"iconset=1 : Text (utf)")
  cb1.append_text(sp+"iconset=0 : Text (ascii)")
  cb1.append_text(sp+"iconset=-1 : Gtk stock icons")
  cb1.append_text(sp+"iconset=-3 : Ghost Flat")
  cb1.append_text(sp+"iconset=-4 : Buuf3.10")
  cb1.append_text(sp+"iconset=-5 : Clarity-icon-theme_0.4.0")
  cb1.show()
  i1=[1, 0, -1, -3, -4, -5]
  i2=i1.index(self.iconset)
  cb1.set_active(i2)

  cb2=gtk.combo_box_new_text()
  cb2.append_text(sp+"listtype=0 : full path")
  cb2.append_text(sp+"listtype=1 : filename")
  cb2.append_text(sp+"listtype=2 : dir/filename")
  cb2.show();
  i1=[0, 1, 2]
  i2=i1.index(self.LISTTYPE)
  cb2.set_active(i2)

  cb3=gtk.combo_box_new_text()
  cb3.append_text(sp+"style_me=0 : unstyled (system theme)")
  cb3.append_text(sp+"style_me=1 : flat-grey")
  cb3.append_text(sp+"style_me=2 : slick gradients")
  cb3.append_text(sp+"style_me=3 : winamp skin")
  cb3.show();
  i1=[0, 1, 2, 3]
  i2=i1.index(self.style_me)
  cb3.set_active(i2)

  tb1=gtk.ToggleButton("volume as slider"); tb1.set_active(self.volume_as_slider); tb1.show();
  tb2=gtk.ToggleButton("i like buttons"); tb2.set_active(self.i_like_buttons); tb2.show();
  tb3=gtk.ToggleButton("full screen"); tb3.set_active(self.fullscreen); tb3.show();

  sp1=gtk.HBox(0, 10)
  l=gtk.Label("def size (in mm): "); l.set_alignment(1.0, 0.5)
  adj=gtk.Adjustment(self.defsize, 1.0, 30.0, 1.0, 3.0, 0.0)
  spi1=gtk.SpinButton(adj, 0, 0); spi1.set_wrap(0)
  spb1=self.nb("[+]","plus"); spb1.connect("clicked", self.spinme, spi1, +1)
  spb2=self.nb("[-]","minus"); spb2.connect("clicked", self.spinme, spi1, -1)

  sp1.pack_start(l, 0, 1, 0)
  sp1.pack_start(spi1, 0, 1, 0)
  sp1.pack_start(spb1, 0, 1, 0)
  sp1.pack_start(spb2, 0, 1, 0)
  l.show(); spi1.show(); spb1.show(); spb2.show(); sp1.show();


  box3.pack_start(cb1, 0, 0, 10)
  box3.pack_start(cb2, 0, 0, 10)
  box3.pack_start(cb3, 0, 0, 10)
  box3.pack_start(tb1, 0, 0, 10)
  box3.pack_start(tb2, 0, 0, 10)
  box3.pack_start(tb3, 0, 0, 10)
  box3.pack_start(sp1, 0, 0, 10)

  sw = gtk.ScrolledWindow(); sw.add_with_viewport(box3); sw.show()
  sw.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)

  box2=gtk.VBox(0,0); box2.show();
  b1=self.nb("[o]", "ok"); b1.show(); b1.connect("clicked", self.opts_apply, cb1, cb2, cb3, tb1, tb2, tb3, spi1)
  b2=self.nb("[x]", "cancel"); b2.show(); b2.connect("clicked", self.opts_destroy)

  box2.pack_start(te0, 0, 0, 10)
  box2.pack_start(b1, 0, 0, 10)
  box2.pack_start(b2, 0, 0, 10)
  box1.pack_start(box2, 0, 0, 10)
  box1.pack_start(sw, 1, 1, 70)

  b1.set_flags(gtk.CAN_DEFAULT); b1.grab_default(); w.show(); self.wopts=w
  try: self.info_destroy(None, None)
  except: pass


 def mm(self, a): return a*10*self.dpi/254

 def s2t(self, s):
  s=int(s)
  if(s<0): s=0
  m=s/60
  if(m>0): s-=m*60
  if(m<10): tm="0"+str(m)
  else: tm=str(m)
  if(s<10): ts="0"+str(s)
  else: ts=str(s)
  return tm+":"+ts

 def set_ln(self, a2): # listname
  self.listname=a2
  if(self.small==1): self.w0.set_title(a2)
  else: self.l_listname.set_text(a2)

 def set_cn(self, a2): # curname
  self.curname=a2
  if(self.style_me==3): self.l_curname.set_text(a2); return
  if(self.small==1): self.w0.set_title(a2)
  else: self.l_curname.set_text(a2)

 def iconify(self, widget, data=None):
  self.w0.iconify()

 def toggle_fs(self, widget, data=None):
  if(self.fullscreen>0): self.fullscreen=0; self.w0.unfullscreen()
  else: self.fullscreen=1; self.w0.fullscreen()
  if(widget!=None): self.config_trig=1

 def toggle_style(self, widget, data=None):
  if(self.style_me==3): self.style_me=2;
  else: self.style_me=3;
  self.save_conf()
  exe=sys.executable; os.execl(exe, exe, * sys.argv)

  return
  self.dontquityet=1
  if(self.style_me==3): self.style_me=2; self.w1.destroy(); self.w0.destroy(); self.setup_window()
  else: self.style_me=3; self.w0.destroy(); self.setup_window_wa()

  self.w0.show(); self.w0.connect("key-press-event", self.key_press_event)
  self.w0.window.property_change(gtk.gdk.atom_intern("_HILDON_ZOOM_KEY_ATOM"), gtk.gdk.atom_intern("INTEGER"), 32, gtk.gdk.PROP_MODE_REPLACE, [1]);


 def say(self, a):
  if(self.cfail==0): self.sock.sendall(a+"\n")

 def volI(self, widget, data="None"): self.say("VOL+")
 def volD(self, widget, data="None"): self.say("VOL-")
 def rep(self, widget, data="None"): self.say("REPEAT")
 def shu(self, widget, data="None"):
  self.say("SHUFFLE")
 def vid(self, widget, data="None"): self.say("VIDS")
 def prev(self, widget, data="None"): self.say("PREV")
 def rwnd(self, widget, data="None"): self.say("RWND")
 def pause(self, widget, data="None"): self.say("PAUSE")
 def ffwd(self, widget, data="None"):
  if(self.state==3): self.say("FFWD")
  elif(self.state==4): self.pause(None,None)
  else: self.loadcur()
 def next(self, widget, data="None"): self.say("NEXT")
 def play(self, widget, data="None"): self.say("LOAD")
 def loadcur(self): self.load(self.lcur)
 def load(self, n): self.say("LOAD "+str(n))
 def playpause(self, widget, data="None"):
  if(self.state==3 or self.state==4): self.say("PAUSE")
  else:
   if(self.lcur<=0): self.say("NEXT")
   else: self.loadcur()
 def stop(self, widget, data="None"): self.say("STOP")
 def quitc(self, widget, data="None"): self.say("QUIT")
 def conn(self, widget, data="None"): self.mkconn()

 def show_vol(self, a2):
  if(self.style_me!=3):
   if(self.volume_as_slider==0): self.l_vol.set_label("Vol "+a2)
   else: self.pb_2.set_fraction(float(a2)/100.0); self.pb_2.set_text(str(a2)+"%")
  else:
  # volbar: 136x28  offs: 214,114  posha: 16
#  self.pb_2.set_fraction(float(a2)/100.0); self.pb_2.set_text(str(a2)+"%")
#   x=int((136.0-28.0)*float(a2)/100.0)
   pp=int(a2)*29/100
   if(pp<0): pp=0
   if(pp>27): pp=27
   x=107*2+2*((68-14)*pp/28)
   self.seti(self.eb_2.get_child(), self.skind+"vol_"+str(pp)+".png")
   self.wa.move(self.eb_4,int(self.ss*( x )),int(self.ss*116))

 def show_bal(self, a2):
  if(self.style_me!=3): pass
  else:
   pp=int(a2+100)*29/200
   x=177*2+2*((38-14)*pp/28)
   if(pp<0): pp=0;
   if(pp>27): pp=27;
#   n=self.skind+"bal_"+str(pp)+".png"; print n
   self.seti(self.eb_5.get_child(), self.skind+"bal_"+str(pp)+".png")
   self.wa.move(self.eb_6,int(self.ss*( x )),int(self.ss*116))

 def show_shu(self):
  a2=self.i_shu
  if(self.style_me!=3):
   if(self.small==0): self.b_shu.set_label("Shu ["+a2+"]")
   else: self.b_shu.set_label("S:"+a2)
  else:
   if(a2=="0"): self.seti(self.b_shu.get_child(),self.skind+"shu.png");
   else: self.seti(self.b_shu.get_child(),self.skind+"shu2.png");
 def show_rep(self):
  a2=self.i_rep
  if(self.style_me!=3):
   if(self.small==0): self.b_rep.set_label("Rep ["+a2+"]")
   else: self.b_rep.set_label("R:"+a2)
  else:
   if(a2=="0"): self.seti(self.b_rep.get_child(),self.skind+"rep.png");
   else: self.seti(self.b_rep.get_child(),self.skind+"rep2.png");
 def show_vid(self, a2):
  if(self.style_me!=3):
   if(self.small==0): self.b_vid.set_label("Vid ["+a2+"]")
   else: self.b_vid.set_label("V:"+a2)
 def show_scrob(self, a2):
  if(self.style_me!=3):
   if(a2=="0"): self.b_sclove.hide();
   else: self.b_sclove.show();
   if(self.small==0): self.b_sctog.set_label("Scrob ["+a2+"]")
   else: self.b_sctog.set_label("Sc"+a2)
 def show_eq(self, a2):
  if(self.style_me!=3):
   if(self.small==0): self.b_eq.set_label("Eq ["+a2+"]")
   else: self.b_eq.set_label("Eq"+a2)

 def keep_awake(self): # blank only for gst slave launched locally, only for n900 now
  if(self.curtype!=15 or self.HOST!="127.0.0.1"): return;
  #if(self.curtype!=2): return; # debug
  if(self.id=='n900'):
   self.keep_awake_trig+=1
   if(self.keep_awake_trig<30): return;
   #print "KA"
   self.keep_awake_trig=0
   self.mceRequest.req_display_blanking_pause()

 def tell_me_about(self,s): return (type(s), s)
 def parse_line(self,a,l):
  #print str(a)
  if(l<=1): return
  p=a.find("=")
  if(p<=0): p=l
  a1=a[0:p]
  #a2=a[p+1:]
  #a2=unicode(a[p+1:], 'iso8859-2') #.encode("utf-8")
  a2=a[p+1:].decode('latin2')
  #print self.tell_me_about(a2)
  #print str(a2)

  if(a1=="TIME"):
   self.time=int(a2); self.l_time.set_label(self.s2t(a2))
   if(self.time!=self.last_time): self.last_time=self.time; self.keep_awake();

   if(self.ttime>0):
    p=self.time*100/self.ttime;
    if(p<0): p=0;
    elif(p>100): p=100;
    if(self.style_me!=3):
     if(p!=self.lastperc): self.lastperc=p;
     self.pb_1.set_fraction(float(p)/100.0)
     self.pb_1.set_text(self.s2t(a2)+" ["+self.s2t(self.ttime)+"]")
    else: 
     # posbar: 496  offs: 32,144  posha: 58
     x=int((496.0-58.0)*float(p)/100.0)
     self.wa.move(self.eb_3,int(self.ss*(32+x)),int(self.ss*144))
  elif(a1=="STATE"):
   t=int(a2); self.state=t; self.l_state.set_label(self.state2label(t))
   if(self.style_me!=3):
    if(self.iconset>=0): # play l15, pause l12
     if(t==3): self.b_playpause.set_label(self.l12)
     else:     self.b_playpause.set_label(self.l15)
   # doesn't work properly on n8x0
   #else:
   # if(t==3): self.b_playpause.set_image(self.i_pause)
   # else:     self.b_playpause.set_image(self.i_play)
  elif(a1=="TTIME"):
   self.ttime=int(a2);
   if(self.ttime>0): self.l_ttime.set_label(self.s2t(a2))
   else: self.l_ttime.set_label("")
  elif(a1=="D"): self.set_cn(a2)
  elif(a1=="CURNAME"):
   self.set_cn(a2)
   if(self.id=="pc"): print " |> "+str(a2)
  elif(a1=="CUR"):
   oc=self.cur; c=int(a2); self.cur=c; olc=self.lcur; self.lcur=c
#   print "oc:"+str(oc)+", c:"+str(c)+", ct:"+str(self.curtype)+", olc:"+str(olc)+", lc:"+str(self.lcur)

   # bold/unbold
   try: ti = self.ts.iter_nth_child(None, oc); self.ts.set_value(ti, 1, 400)
   except: pass
   ti = self.ts.iter_nth_child(None, c); self.ts.set_value(ti, 1, 700)

   self.curtype=self.ts.get_value(ti,2)
   self.tv_show(c)

  elif(a1=="LISTNAME"): self.set_ln(a2)
  elif(a1=="SHUFFLE"): self.i_shu=a2; self.show_shu()
  elif(a1=="REPEAT"): self.i_rep=a2; self.show_rep()
  elif(a1=="VIDS"): self.show_vid(a2)
  elif(a1=="SCROB"): self.show_scrob(a2)
  elif(a1=="VOL"): self.vol=a2; self.show_vol(a2)
  elif(a1=="FREQ"):
   lab="";
   #if(int(a2)<=0): self.l_freq.set_label(""); return
   if(self.style_me!=3): lab="kHz "; lab="k"
   self.l_freq.set_label(" "+str(int(a2)/1000)+lab)
  elif(a1=="BITRATE"):
   t=int(a2); lab=""
   if(self.style_me!=3): lab="kbps "; lab="k"
   if(1 or t>0): self.l_bitrate.set_label(" "+a2+lab)
   #else: self.l_bitrate.set_label("  ")
  elif(a1=="CHAN"):
   self.i_chan=a2; lab="ch "; lab="ch"
   if(1 or int(a2)>0): self.l_chan.set_label(" "+a2+lab)
   else: self.l_chan.set_label("")
  elif(a1=="EQ"):
#   print "EQ: "+str(a2)
   self.eq,self.eq60,self.eq170,self.eq310,self.eq600,self.eq1k,self.eq3k,self.eq6k,self.eq12k,self.eq14k,self.eq16k,self.eq22k=a2.split(" ")
#   self.show_eq(self.eq)
   self.eq=int(self.eq)
   self.eq60=float(self.eq60); self.eq170=float(self.eq170); self.eq310=float(self.eq310)
   self.eq600=float(self.eq600); self.eq1k=float(self.eq1k); self.eq3k=float(self.eq3k)
   self.eq6k=float(self.eq6k); self.eq12k=float(self.eq12k); self.eq14k=float(self.eq14k)
   self.eq16k=float(self.eq16k); self.eq22k=float(self.eq22k)
   self.update_eq()

  elif(a1=="CONF"):
   #print "CONF: "+str(a2)
   p1,p2=a2.split(" ")
   if(p1=="EQ"): self.eq=int(p2); self.update_eq()
   elif(p1=="EFFECTS"):
    try: p2=int(p2)
    except: return
    self.eff=p2; self.update_eff()

  elif(a1=="TITLE"): self.i_title=a2
  elif(a1=="ARTIST"): self.i_artist=a2
  elif(a1=="ALBUM"): self.i_album=a2
  elif(a1=="GENRE"): self.i_genre=a2
  elif(a1=="YEAR"): self.i_year=a2
  elif(a1=="COMMENT"): self.i_comment=a2
  elif(a1=="LIST_START"):
   self.timsta0=time.clock()
   self.ts.clear(); self.lcur=0; t=int(a2)
   self.tv.freeze_child_notify()
#   mo=self.tv.get_model() # disable sorting
#   mo.set_default_sort_func(lambda *unused: 0) # <-- can also use None but that is slower!
#   mo.set_sort_column_id(-1, gtk.SORT_ASCENDING)
#   self.tv.set_model(mo)
#   self.tv.set_model(None)
 # change rows
# model.set_sort_column_id(*sortSettings)
   if(t<0): t=0
   self.set_cn("New list: "+a2+" entries")
  elif(a1=="LIST_END"):
   self.tv.thaw_child_notify()
   ts=time.clock(); s="Loaded "+str(self.lmax)+" in "+str(round(ts-self.timsta0,2))+"s"
#   print s
   self.set_cn(s)
  elif(a1[0:3]=="NAM"):
   p=a1.find("]")
   if(p<0): return
   p2=a2.find(",")
   if(p2<=0): return
   n=int(a1[5:p])
   t=int(a2[:p2])
   p2+=1; nam=str(n)+"  "+a2[p2:]
   if(t<0): nam+="/"
#   print str(n)+"|"+nam+"|"+str(t)
   self.ts.append([nam, 400, t])
   self.lmax=n
#  elif(a1[0:4]=="TYPE"): pass
  elif(a1=="HELLO"): self.corev=a2;
  elif(a1=="COREQUIT"): self.set_cn(a2); self.clconn()
  #else: print "[unhandled msg: "+str(l)+","+a1+","+a2+"]"

 def tv_show(self, c):
  self.tv.set_cursor(c)
  self.tv.scroll_to_cell((c,), None, True, 0.5, 0)

 def tv_click(self, tv, ev):
  if ev.button == 1:
   p = tv.get_path_at_pos(int(ev.x), int(ev.y))
   if p is None: return
   path, col, x, y = p; a="LOAD "+str(tv.get_model()[path][0])
   self.say(a) # load current index

 def mrl(self, eb, ev, q):
  if(q!=""): q=" *"+str(q)+"*"
  self.say("MAKE_RECURSIVE_LIST"+q)
 def go_root(self, eb, ev): self.say("GO_ROOT")
 def go_parent(self, eb, ev): self.load(0)
 def go_top(self, eb, ev): self.tv_show(0)
 def go_cur(self, eb, ev): self.tv_show(self.lcur)
 def go_end(self, eb, ev): self.tv_show(self.lmax)
 def go_pgup(self, eb, ev): pass
 def go_pgdn(self, eb, ev): pass

 def favSH(self, eb):
  if(self.i_like_buttons>0): self.i_like_buttons=0; self.box_lnavMB.hide();
  else: self.i_like_buttons=1; self.box_lnavMB.show();
  if(eb!=None): self.config_trig=1

 def favR(self, eb, ev):
  if(self.favRstate==0): self.favRstate=1; self.b_lfR.set_label("M");
  else: self.favRstate=0; self.b_lfR.set_label("m");

 def loadfav(self, eb, a, ev):
  if(a<0 or a>9): return
  if(self.favRstate==0): self.say("LOADFAV "+str(a))
  else: self.favR(None, None); self.say("SETFAV "+str(a))

 def pb1_click(self, eb, ev):
  #if(self.ttime<=0): print "no ttime"; return
  if(self.style_me!=3):
   t=round(ev.x*self.ttime/eb.get_allocation().width); self.say("SEEK "+str(t))
  else:
   # posbar: 496  offs: 32,144  posha: 58
   t=round((ev.x-58/2)*self.ttime/(eb.get_allocation().width-58));
   if(t<0): t=0
   if(t>self.ttime): t=self.ttime;
   #print "tt:"+str(self.ttime)+", t:"+str(t)
   self.say("SEEK "+str(t))

 def pb2_click(self, eb, ev):
  if(self.style_me!=3):
   t=round(ev.x*100/eb.get_allocation().width); self.say("VOLS "+str(t))
  else:
   # volbar: 136x28  offs: 220,114  posha: 16
   t=round((ev.x-16/2)*100/(eb.get_allocation().width-16));
   if(t<0): t=0
   if(t>100): t=100;
   #print "v:"+str(t)
   self.say("VOLS "+str(t))

 def handle_data(self, s, cond):
  try: buf=self.hdb+s.recv(4096); self.hdb=""; l=len(buf); opos=0; pos=0
  except: l=0
  if(l<=0): self.hdb=""; self.clconn(); return 1
  while (self.cfail==0 and pos>=0 and pos<l):
   pos=buf.find("\n",opos)
   if pos==-1: self.hdb=buf[opos:]
   else: line=buf[opos:pos-1]; self.parse_line(line,pos-1-opos); opos=pos+1
  return 1

 def d(self, a): self.l_curname.set_text(a);

 def close(self, widget, data=None): self.swp('close'); self.w0.destroy()
 def delete_event(self, widget, event, data=None): self.swp('del_ev'); return 0

 dontquityet=0
 def destroy(self, widget, data=None):
  if(self.dontquityet): self.dontquityet=0; print "dqy"
  else:
   self.swp('destroy')
   if(self.config_trig): self.save_conf()
   gtk.main_quit()

 def init_conf(self):
  try: f=open("/proc/cpuinfo","rb"); a=f.read()
  except: a=""; pass
  if(self.id==""):
   if(a.find("Nokia N800")>0 or a.find("Nokia RX-44")>0): self.id="n8x0";
   elif(a.find("Nokia N810")>0 or a.find("Nokia RX-48")>0): self.id="n8x0";
   elif(a.find("Nokia N900")>0 or a.find("Nokia RX-51")>0): self.id="n900";
   else: self.id="pc";
  print "inited as: "+self.id
  self.style_me=2; self.iconset=-3; self.small=1; self.fullscreen=0; self.ss=1.0; self.small=1;
  self.skins_lastdir=expanduser("~"); self.skind="/opt/oscp/share/images/skin/";
  self.volume_as_slider=1; self.LISTTYPE=2; self.i_like_buttons=0; self.oscp_bin="oscp"
  self.defsize=7;
  if(self.id=="pc"): self.dpi=96; self.ww=400; self.wh=200
  elif(self.id=="n8x0"): self.ss=1.3; self.dpi=225; self.ww=800; self.wh=480
  elif(self.id=="n900"): self.ss=1.45; self.dpi=267; self.ww=800; self.wh=480
  self.save_conf();

 def save_conf(self):
  print "saving config ("+str(self.config_trig)+")"
  self.config_trig=0
  self.config_ver=21
  if(self.HOST==""): return
  try: f=open(expanduser("~")+"/.oscp-remote.conf","wb")
  except: return
  if(self.PORT<=0 or self.PORT>65535): self.PORT=44322
  a="config_ver="+str(self.config_ver)+"\n"
  a+="id="+self.id+"\n"
  a+="oscp_bin="+str(self.oscp_bin)+"\n"
  a+="skins_lastdir="+self.skins_lastdir+"\n"
  a+="skin_dir="+self.skind+"\n"
  a+="current_skin="+self.current_skin+"\n"
  a+="lasthost="+self.HOST+"\nlastport="+str(self.PORT)+"\n"
  a+="ww="+str(self.ww)+"\n"
  a+="wh="+str(self.wh)+"\n"
  a+="wx="+str(self.wx)+"\n"
  a+="wy="+str(self.wy)+"\n"
  a+="dpi="+str(self.dpi)+"\n"
  a+="# ss: style scale factor (for style_me==3)\n"
  a+="ss="+str(self.ss)+"\n"
  a+="fullscreen="+str(self.fullscreen)+"\n"
  a+="i_like_buttons="+str(self.i_like_buttons)+"\n"
  a+="volume_as_slider="+str(self.volume_as_slider)+"\n"
  a+="small="+str(self.small)+"\n"
  a+="# defsize: buttons size in mm\n"
  a+="defsize="+str(self.defsize)+"\n"
  a+="# list_type: 0:full path, 1:filename, 2:parentdir+filename\n"
  a+="list_type="+str(self.LISTTYPE)+"\n"
  a+="# iconset: [-5..2], negative for using iconN dirs to find icons\n"
  a+="iconset="+str(self.iconset)+"\n"
  a+="# style_me: 0:unstyled, 1:grey-flat, 2:gradients, 3:winamp-skin\n"
  a+="style_me="+str(self.style_me)+"\n"
  f.write(a); f.close()

 def load_conf(self):
  try: f=open(expanduser("~")+"/.oscp-remote.conf","rb")
  except:
   print "config not found (~/.oscp-remote.conf), using defaults";
   self.init_conf();
   return 1
  for line in f:
   if(line.startswith('config_ver=')):
    try: self.config_ver=int(line[11:].rstrip())
    except: pass
   if(line.startswith('id=')): self.id=line[3:].rstrip()
   if(line.startswith('oscp_bin=')): self.oscp_bin=line[9:].rstrip()
   if(line.startswith('skins_lastdir=')): self.skins_lastdir=line[14:].rstrip()
   if(line.startswith('skin_dir=')): self.skind=line[9:].rstrip()
   if(line.startswith('current_skin=')): self.current_skn=line[13:].rstrip()
   if(line.startswith('lasthost=')): self.HOST=line[9:].rstrip()
   if(line.startswith('lastport=')):
    try: self.PORT=int(line[9:].rstrip())
    except: pass
   if(line.startswith('ww=')):
    try: self.ww=int(line[3:].rstrip())
    except: pass
   if(line.startswith('wh=')):
    try: self.wh=int(line[3:].rstrip())
    except: pass
   if(line.startswith('wx=')):
    try: self.wx=int(line[3:].rstrip())
    except: pass
   if(line.startswith('wy=')):
    try: self.wy=int(line[3:].rstrip())
    except: pass
   if(line.startswith('dpi=')):
    try: self.dpi=int(line[4:].rstrip())
    except: pass
   if(line.startswith('ss=')):
    try: self.ss=float(line[3:].rstrip())
    except: pass
   if(line.startswith('fullscreen=')):
    try: self.fullscreen=int(line[11:].rstrip())
    except: pass
   if(line.startswith('i_like_buttons=')):
    try: self.i_like_buttons=int(line[15:].rstrip())
    except: pass
   if(line.startswith('list_type=')):
    try: self.LISTTYPE=int(line[10:].rstrip())
    except: pass
   if(line.startswith('volume_as_slider=')):
    try: self.volume_as_slider=int(line[17:].rstrip())
    except: pass
   if(line.startswith('small=')):
    try: self.small=int(line[6:].rstrip())
    except: pass
   if(line.startswith('defsize=')):
    try: self.defsize=int(line[8:].rstrip())
    except: pass
   if(line.startswith('iconset=')):
    try: self.iconset=int(line[8:].rstrip())
    except: pass
   if(line.startswith('style_me=')):
    try: self.style_me=int(line[9:].rstrip())
    except: pass
  f.close()
  if(self.config_ver<21):
   print "old config version ("+str(self.config_ver)+") detected, reiniting"; self.init_conf()
  return 0

 def clconn(self):
  self.cfail=1; self.corev="disconnected."
  try: gobject.source_remove(self.iowatch)
  except: pass
  try: self.sock.close()
  except: pass
  self.set_ln(""); self.set_cn("disconnected."); self.pb_1.set_fraction(0); self.ts.clear()

 def mkconn(self):
  self.clconn()
  self.sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM); self.sock.settimeout(3);
  try:    self.sock.connect((self.HOST, self.PORT)); self.cfail=0
  except: self.d('can\'t connect to: %s:%d' % (self.HOST, self.PORT))

  if(self.cfail==0):
   self.set_cn("connected to "+self.HOST)
   self.iowatch=gobject.io_add_watch(self.sock, gobject.IO_IN, self.handle_data)
   self.say("EHLO "+str(self.LISTTYPE))

 def getText_OK(self, ent, dia, res): dia.response(res)
 def getText(self, question, hint):
  dialog = gtk.MessageDialog(None, gtk.DIALOG_MODAL | gtk.DIALOG_DESTROY_WITH_PARENT,
   gtk.MESSAGE_QUESTION, gtk.BUTTONS_OK_CANCEL, question)
  entry = gtk.Entry(); entry.set_text(hint)
  entry.connect("activate", self.getText_OK, dialog, gtk.RESPONSE_OK)
  dialog.vbox.pack_end(entry, 0, 0, 0); dialog.show_all(); ret=dialog.run()
  if(ret==-5): self.config_trig=1; text=entry.get_text();
  else: text="-77777"
  dialog.destroy(); return text

 def connectto(self, widget, data=None):
  r=self.getText("Connect to HOST:PORT", self.HOST+":"+str(self.PORT))
  if(r=="-77777"): return
  h=""; p=self.PORT
  try: h,p=r.split(':')
  except: h=r
  try: self.PORT=int(p)
  except: pass
  if(h!=""): self.HOST=h; self.mkconn(); self.config_trig=1;

 def sloacti(self, widget, data=None): # spawn local oscp and connect to i
  self.config_trig=1
  self.set_cn("spawning local core")
  if(self.PORT<=0): self.PORT=44322
  os.system("killall oscp"); os.system(self.oscp_bin+" -a 1 -d 1 -L "+str(self.PORT)); time.sleep(1);
  self.HOST="127.0.0.1"; self.mkconn();

 def getText_mrl_OK(self, ent, dia, res): dia.response(res)
 def getText_mrl(self, question, hint):
  dialog = gtk.MessageDialog(None, gtk.DIALOG_MODAL | gtk.DIALOG_DESTROY_WITH_PARENT,
   gtk.MESSAGE_QUESTION, gtk.BUTTONS_OK_CANCEL, question)
  entry = gtk.Entry(); entry.set_text(hint)
  entry.connect("activate", self.getText_mrl_OK, dialog, gtk.RESPONSE_OK)
  dialog.vbox.pack_end(entry, 0, 0, 0); dialog.show_all(); ret=dialog.run()
  if(ret==-5): text=entry.get_text();
  else: text="-77777"
  dialog.destroy(); return text
 def mrl_filt(self, widget, data=None):
  r=self.getText_mrl("Make recursive list and look for:", self.last_mrl_filt)
  if(r=="-77777"): return
  self.last_mrl_filt=r
  self.mrl(None,None,r)

 def show_top(self, widget, data=None): self.lcur=0; self.tv_show(self.lcur)
 def show_end(self, widget, data=None): self.lcur=self.lmax; self.tv_show(self.lcur)
 def show_pgup(self, widget, data=None):
  self.lcur-=10
  if(self.lcur<0): self.lcur=0
  self.tv_show(self.lcur)
 def show_pgdn(self, widget, data=None):
  self.lcur+=10
  if(self.lcur>self.lmax): self.lcur=self.lmax
  self.tv_show(self.lcur)

 def key_press_event(self, widget, ev):
  self.swp('kpe')
  k=ev.keyval
#khe
  if(k==65361): self.go_parent(None,None) #LEFT
  elif(k==65363 or k==65293 or k==65421): self.load(self.lcur) # RIGHT or ENTER or NUM-ENTER (n900)
  elif(k==65362):				# UP
   if(self.lcur>0): self.lcur-=1; self.tv_show(self.lcur);
#    self.tv_show(self.lcur); self.tv.set_cursor(self.lcur)
  elif(k==65364):				# DOWN
   if(self.lcur<self.lmax): self.lcur+=1; self.tv_show(self.lcur);
#    self.tv_show(self.lcur); self.tv.set_cursor(self.lcur)
  elif(k==65360): self.show_top(None,None)	# HOME
  elif(k==65367): self.show_end(None,None)	# END
  elif(k==65365): self.show_pgup(None,None)	# PGUP
  elif(k==65366): self.show_pgdn(None,None)	# PGDN
  elif(k==113 or k==65307): self.w0.destroy()	# q or ESC
  elif(k==108): self.mrl_filt(None,"")		# l
  elif(k==112): self.playpause(None,None)	# p
  elif(k==115): self.shu(None,None)		# s
  elif(k==114): self.rep(None,None)		# r
  elif(k==92): self.stop(None,None)		# \\
  elif(k==91): self.prev(None,None)		# [
  elif(k==93 or k==32): self.next(None,None)	# ] or SPACE
  elif(k==44): self.rwnd(None,None) 		# ,
  elif(k==46): self.ffwd(None,None) 		# .
  elif(k==61 or k==43): self.volI(None,None) 	# = or +
  elif(k==95 or k==45): self.volD(None,None) 	# _ or -
  elif(k==102):			    		# f toggle fullpath
   self.config_trig=1; self.LISTTYPE+=1
   if(self.LISTTYPE>2): self.LISTTYPE=0
   self.say("EHLO "+str(self.LISTTYPE))
  elif(k==59): self.mrl(None,None,"") # ; (make recursive list)
  elif(k==99): self.connectto(None,None)	# c
  elif(k==120): self.quitc(None,None)		# x
  elif(k==104 or k==65470): self.help(None,None) # h or F1
  elif(k==105): self.info(None,None)		# i
  elif(k==111): self.opts(None,None)		# o
  elif(k==101): self.eq_showhide(None,None)	# e
  elif(k==119): self.playlist_showhide(None,None) # w
  elif(k==69): self.eq_tog(None)		# E
  elif(k==70): self.eff_flanger_tog(None)	# F
  elif(k==87): self.eff_earwax_tog(None)	# W
  elif(k==67): self.eff_contrast_tog(None)	# C
  elif(k==86): self.eff_reverb_tog(None)	# V
  elif(k==79): self.eff_overdrive_tog(None)	# O
  elif(k==75): self.eff_karaoke_tog(None)	# K
  elif(k==48): self.loadfav(None,0,None)	# 0
  elif(k==49): self.loadfav(None,1,None)	# 1
  elif(k==50): self.loadfav(None,2,None)	# 2
  elif(k==51): self.loadfav(None,3,None)	# 3
  elif(k==52): self.loadfav(None,4,None)	# 4
  elif(k==53): self.loadfav(None,5,None)	# 5
  elif(k==54): self.loadfav(None,6,None)	# 6
  elif(k==55): self.loadfav(None,7,None)	# 7
  elif(k==56): self.loadfav(None,8,None)	# 8
  elif(k==57): self.loadfav(None,9,None)	# 9
  elif(k==109): self.favR(None,None)		# m
  elif(k==65477 and self.id=="n900"): self.prev(None,None) # n900: hw -
  elif(k==65476 and self.id=="n900"): self.next(None,None) # n900: hw +
  elif(k==65477 and self.id=="n8x0"): self.prev(None,None) # n800: hw -
  elif(k==65476 and self.id=="n8x0"): self.next(None,None) # n800: hw +
  elif(k==65475 and self.id=="n8x0"): pass	# n800: hw []
  elif(k==65474 and self.id=="n8x0"): pass	# n800: hw home (but will popup system menu)
  elif(k==65473 and self.id=="n8x0"): pass	# n800: hw menu
  else:
   #print "key_press_event: "+str(k)
   self.set_cn("key: "+str(k))
   return False
  return True

 def swp(self, a): # store window position
  #print "swp: a: "+a
  x,y=self.w0.get_position()
  w,h=self.w0.get_size()
#  print "swp: xy: "+str(x)+","+str(y)+" wxy: "+str(self.wx)+","+str(self.wy)
  if(x==0 and y==0): return
  if(x!=self.wx or y!=self.wy or w!=self.ww or h!=self.wh):
   self.ww=w; self.wh=h;
   self.wx=x; self.wy=y; self.config_trig=1

 def nb2(self,w,h):
  b=gtk.Button(); b.set_focus_on_click(0);
  b.set_size_request(self.mm(w),self.mm(h)); hb = gtk.HBox(); vb = gtk.VBox()
  vb.pack_start(b, False, False); hb.pack_start(vb, False, False);
  b.show(); vb.show(); hb.show();
  return b

 def ico2fn(self,ico):
  return;

 def seti(self, i, fn):
  if(fn[0:1]!="/"): pp=self.pixpa;
  else: pp=""
  try:
   pb=gtk.gdk.pixbuf_new_from_file(pp+fn)
   w=pb.get_width(); h=pb.get_height()
   if(w<4 and h<4): i.clear(); return
   spb=pb.scale_simple(int(self.ss*w),int(self.ss*h),gtk.gdk.INTERP_BILINEAR)
   i.set_from_pixbuf(spb)
  except: i.clear();


 icons={
  'plus' :['icons/plus.png', gtk.STOCK_ADD],
  'minus':['icons/minus.png',gtk.STOCK_REMOVE],
  'ok'  :['icons/ok.png',   gtk.STOCK_OK],
  'cancel':['icons/cancel.png',gtk.STOCK_CANCEL],
  'pause':['icons/pause.png',gtk.STOCK_MEDIA_PAUSE],
  'play':['icons/play.png', gtk.STOCK_MEDIA_PLAY],
  'stop':['icons/stop.png', gtk.STOCK_MEDIA_STOP],
  'prev':['icons/prev.png', gtk.STOCK_MEDIA_PREVIOUS],
  'rwnd':['icons/rwnd.png', gtk.STOCK_MEDIA_REWIND],
  'ffwd':['icons/ffwd.png', gtk.STOCK_MEDIA_FORWARD],
  'next':['icons/next.png', gtk.STOCK_MEDIA_NEXT],
  'volD':['icons/volD.png', gtk.STOCK_REMOVE],
  'volI':['icons/volI.png', gtk.STOCK_ADD],
  'volM':['icons/volM.png', gtk.STOCK_CANCEL],
  'sloacti':['icons/cspawn.png',gtk.STOCK_EXECUTE],
  'cquit':['icons/cquit.png',gtk.STOCK_CANCEL],
  'cconn':['icons/cconn.png',gtk.STOCK_NETWORK],
  'quit':['icons/quit.png', gtk.STOCK_QUIT],
  'opts':['icons/opts.png', gtk.STOCK_PROPERTIES],
  'help':['icons/help.png', gtk.STOCK_HELP],
  'info':['icons/info.png', gtk.STOCK_DIALOG_INFO],
  'maxi':['icons/maxi.png', gtk.STOCK_FULLSCREEN],
  'mrl': ['icons/mrl.png',  gtk.STOCK_SELECT_ALL],
  'goroot':['icons/unk.png',-1],
  'gopare':['icons/gopare.png',gtk.STOCK_UNDO],
  'gotop': ['icons/gotop.png', gtk.STOCK_GOTO_TOP],
  'gopgup':['icons/gopgup.png',gtk.STOCK_GO_UP],
  'gocur': ['icons/gocur.png', gtk.STOCK_GO_FORWARD],
  'gopgdn':['icons/gopgdn.png',gtk.STOCK_GO_DOWN],
  'goend': ['icons/goend.png', gtk.STOCK_GOTO_BOTTOM],
  'morebuttons':['icons/morebuttons.png',gtk.STOCK_JUSTIFY_FILL],
  'chstyle':['icons/chstyle.png',gtk.STOCK_CONVERT],
  'shu':['icons/shu.png',-1],
  'rep':['icons/rep.png',-1],
  'vid':['icons/vid.png',-1],
  'eq':['icons/unk.png',-1],
  'UNK':['icons/unk.png',gtk.STOCK_MISSING_IMAGE],
 }

 def setico(self, i, ico, siz): #  print "setico: ico:"+str(ico)+", siz:"+str(siz)
  try:
   ic=self.icons[ico];
   if(ic[0][0:6]=="icons/"): ic[0]="icons"+str(abs(self.iconset))+ic[0][5:]
  except: ic=[ico,gtk.STOCK_MISSING_IMAGE]
  fn=ic[0]
  if(fn[0:1]!="/"): fn=self.pixpa+fn

  try:
   pb=gtk.gdk.pixbuf_new_from_file(fn); w=pb.get_width(); h=pb.get_height();
   if(siz==gtk.ICON_SIZE_BUTTON): sh=self.mm(self.defsize-2); sw=w*sh/h
   spb=pb.scale_simple(sw,sh,gtk.gdk.INTERP_BILINEAR)
   i.set_from_pixbuf(spb)
  except:
   if(ic[1]<0): return 0
   try: i.set_from_stock(ic[1], siz);
   except: print "setico failed"

  return 1

 def nb(self,lab,ico):
  b=self.nb2(self.defsize,self.defsize)
  if(self.iconset<0 and ico!=""):
   im = gtk.Image();
   if(self.setico(im, ico, gtk.ICON_SIZE_BUTTON)): b.set_image(im); return b
  b.set_label(lab)
  return b

 def nbis(self,fn):
  i=gtk.Image(); i.set_from_stock(fn, gtk.ICON_SIZE_BUTTON); i.show()
  eb=gtk.EventBox(); eb.add(i); eb.show(); return eb

 def nbi(self,fn):
  i=gtk.Image(); self.seti(i,fn); i.show()
  eb=gtk.EventBox(); eb.add(i); eb.show(); return eb

 def nbl(self,wid,txt,w,h,x,y):
  i=gtk.Label(); i.set_size_request(int(self.ss*w),int(self.ss*h)); i.show();
  self.npu(wid,i,x,y); return i

 def npu(self,a,b,x,y):
  a.put(b,int(self.ss*x),int(self.ss*y));

 def test(self,a,b): return True

 def eject(self, widget, data=None):
  #self.playlist_showhide(None, None)
  self.connectto(None, None)
  return True

 def playlist_showhide(self, widget, data=None):
  if(self.style_me!=3): return True
  if(self.w1.get_property("visible")): self.w1.hide(); self.seti(self.b_pl.get_child(),self.skind+"pl.png");
  else: self.w1.show(); self.seti(self.b_pl.get_child(),self.skind+"pl2.png");
  return True

 def eq_showhide(self, widget, data=None):
  if(self.style_me==3):
   if(self.w2.get_property("visible")): self.w2.hide(); self.seti(self.b_eq.get_child(),self.skind+"eq.png");
   else: self.w2.show(); self.seti(self.b_eq.get_child(),self.skind+"eq2.png");
  else:
   if(self.w2.get_property("visible")): self.w2.hide()
   else: self.w2.show()
  return True

 def posha(self, widget, data=None):
  #print "posha"
  return False

 def change_skinR(self, widget, data=None):
  try:
   skins=open(expanduser("~")+"/.oscp/skins.dat").read().splitlines()
   skin=random.choice(skins)
   if(skin==""): return
   self.change_skin2(skin)
   self.set_cn("Loaded skin: "+os.path.basename(skin))
   self.current_skin=skin
  except:
   self.set_cn("!! put skin names into ~/.oscp/skins.dat !!")

 def change_skin2(self, sn):
  self.set_cn("Loading skin: "+str(sn))
  if(self.skind=="/opt/oscp/share/images/skin/"): self.skind=expanduser("~")+"/.oscp/skin/"
#  print "change_skin2: "+self.skind
  try: os.makedirs(self.skind)
  except: pass
  os.system("rm \""+self.skind+"\"/*.png")

  if(sn!=None): os.system("/opt/oscp/bin/oscc -s 0 \""+self.skind+"\" \""+sn+"\"")

  if(not(os.path.isfile(self.skind+"main.png"))):
   os.system("cp /opt/oscp/share/images/skin/* ~/.oscp/skin/")
   self.set_cn("Skin load failed")
  else:
   f=open(self.skind+"/0src.txt",'w')
   if(f): f.write(sn); f.close()

  self.seti(self.i_main, self.skind+"main.png")
  self.seti(self.i_titbar, self.skind+"titbar.png")
  self.seti(self.i_num0, self.skind+"numB.png")
  self.seti(self.i_num1, self.skind+"numB.png")
  self.seti(self.i_num2, self.skind+"numB.png")
  self.seti(self.i_num3, self.skind+"numB.png")
  self.seti(self.i_num4, self.skind+"numB.png")
  self.seti(self.b_clubar.get_child(), self.skind+"clubar.png")
  wh=self.b_clubar.get_child().get_allocation()
  if(wh.width<=1 and wh.height<=1):
#   print "clubar_fallback"
   print "clubar: "+str(wh.width)+","+str(wh.height)
   self.seti(self.b_clubar.get_child(),self.skind+"clubar_fallback.png");

  self.seti(self.b_prev.get_child(), self.skind+"prev.png")
  self.seti(self.b_play.get_child(), self.skind+"play.png")
  self.seti(self.b_playpause.get_child(), self.skind+"pause.png")
  self.seti(self.b_stop.get_child(), self.skind+"stop.png")
  self.seti(self.b_next.get_child(), self.skind+"next.png")
  self.seti(self.b_eject.get_child(), self.skind+"eject.png")
  self.show_shu()
  self.show_rep()
  self.seti(self.b_eq.get_child(), self.skind+"eq.png")
  self.seti(self.b_pl.get_child(), self.skind+"pl.png")
  self.seti(self.b_mini.get_child(), self.skind+"b_mini.png")
  self.seti(self.b_maxi.get_child(), self.skind+"b_maxi.png")
  self.seti(self.b_close.get_child(), self.skind+"b_close.png")
  self.seti(self.b_info.get_child(), self.skind+"b_info.png")
  self.seti(self.b_app.get_child(), self.skind+"b_app.png")
  self.seti(self.eb_1.get_child(), self.skind+"posbar.png")
  self.seti(self.eb_3.get_child(), self.skind+"posha.png")
#  self.seti(self.eb_2.get_child(), self.skind+"vol_27.png")
  self.show_vol(self.vol)
  self.seti(self.eb_4.get_child(), self.skind+"volha.png")
  self.show_bal(0)
  self.seti(self.eb_6.get_child(), self.skind+"balha.png")
  if(self.i_chan>1):
   self.seti(self.b_mono.get_child(), self.skind+"mono.png")
   self.seti(self.b_ster.get_child(), self.skind+"ster2.png")
  else:
   self.seti(self.b_mono.get_child(), self.skind+"mono2.png")
   self.seti(self.b_ster.get_child(), self.skind+"ster.png")

  self.grabset_cols()

 def change_skin(self, widget, data=None):
  fs=gtk.FileChooserDialog(title="Select winamp classic skin",action=gtk.FILE_CHOOSER_ACTION_OPEN,
   buttons=(gtk.STOCK_CANCEL,gtk.RESPONSE_CANCEL,gtk.STOCK_OPEN,gtk.RESPONSE_OK))
  sld=self.skins_lastdir
  fs.set_current_folder(expanduser(self.skins_lastdir))
  fs.set_default_response(gtk.RESPONSE_OK)

  fi=gtk.FileFilter(); fi.set_name(".zip/.wsz"); fi.add_pattern("*.zip"); fi.add_pattern("*.wsz"); fs.add_filter(fi)
  fi=gtk.FileFilter(); fi.set_name("All files"); fi.add_pattern("*"); fs.add_filter(fi)

  r=fs.run()
  self.skins_lastdir=fs.get_current_folder()
  if(sld!=self.skins_lastdir): self.save_conf()
  if(r==gtk.RESPONSE_OK):
   self.change_skin2(fs.get_filename())
  fs.destroy()
  self.config_trig=1

# def apply_options(self): pass
# def show_options(self):
#  if(self.id=='n900' or self.id=='n8x0'): w2=gtk.Window(gtk.WINDOW_POPUP); self.ww=800; self.wh=480
#  else: w2 = gtk.Window(gtk.WINDOW_TOPLEVEL);
#  w2.set_default_size(self.ww,self.wh); w2.set_border_width(0); inav=gtk.VBox();

 def grabset_cols(self):
  try:
   col_cn=col_st=col_ti=col_tt=col_ch=col_br=col_fr=1
   i=open(expanduser("~")+"/.oscp/skin/0colors.txt","r")
   if(i):
    for a in i:
     p=a.find("=")
     if(p>0):
      a1=a[0:p]; a2=a[p+1:]
      if(a1=="col_cn"): col_cn=int(a2)
      elif(a1=="col_st"): col_st=int(a2)
      elif(a1=="col_ti"): col_ti=int(a2)
      elif(a1=="col_tt"): col_tt=int(a2)
      elif(a1=="col_ch"): col_ch=int(a2)
      elif(a1=="col_br"): col_br=int(a2)
      elif(a1=="col_fr"): col_fr=int(a2)
    i.close
  except: pass
#  print "cn:"+str(col_cn)+",st:"+str(col_st)+",ti:"+str(col_ti)+",tt:"+str(col_tt)+",ch:"+str(col_ch)

  thre=200
  if(col_cn>thre): self.l_curname.modify_fg(gtk.STATE_NORMAL, gtk.gdk.color_parse('#000'))
  else:            self.l_curname.modify_fg(gtk.STATE_NORMAL, gtk.gdk.color_parse('#fff'))
  if(col_st>thre): self.l_state.modify_fg(gtk.STATE_NORMAL, gtk.gdk.color_parse('#000'))
  else:            self.l_state.modify_fg(gtk.STATE_NORMAL, gtk.gdk.color_parse('#fff'))
  if(col_ti>thre): self.l_time.modify_fg(gtk.STATE_NORMAL, gtk.gdk.color_parse('#000'))
  else:            self.l_time.modify_fg(gtk.STATE_NORMAL, gtk.gdk.color_parse('#fff'))
  if(col_tt>thre): self.l_ttime.modify_fg(gtk.STATE_NORMAL, gtk.gdk.color_parse('#000'))
  else:            self.l_ttime.modify_fg(gtk.STATE_NORMAL, gtk.gdk.color_parse('#fff'))
  if(col_ch>thre): self.l_chan.modify_fg(gtk.STATE_NORMAL, gtk.gdk.color_parse('#000'))
  else:            self.l_chan.modify_fg(gtk.STATE_NORMAL, gtk.gdk.color_parse('#fff'))
  if(col_br>thre): self.l_bitrate.modify_fg(gtk.STATE_NORMAL, gtk.gdk.color_parse('#000'))
  else:            self.l_bitrate.modify_fg(gtk.STATE_NORMAL, gtk.gdk.color_parse('#fff'))
  if(col_fr>thre): self.l_freq.modify_fg(gtk.STATE_NORMAL, gtk.gdk.color_parse('#000'))
  else:            self.l_freq.modify_fg(gtk.STATE_NORMAL, gtk.gdk.color_parse('#fff'))

 ####/////////////////////#
 def setup_window_wa(self):
  if(os.path.isdir(self.skind)): pass
  else: self.skind="/opt/oscp/share/images/skin/";

  ss=self.ss;
  self.w0 = gtk.Window(gtk.WINDOW_TOPLEVEL);
  if(self.ww<=0 or self.wh<=0): self.ww=self.mm(self.defsize)*8; self.wh=self.mm(self.defsize)*7
  self.ww=int(ss*self.ww); self.wh=int(ss*self.wh);
  self.w0.set_default_size(self.ww,self.wh)
  self.w0.set_border_width(0)
  self.w0.set_property("allow-shrink",False)

  self.w0.show()
  self.w0.connect("delete_event", self.delete_event); self.w0.connect("destroy", self.destroy)


  w=gtk.Fixed(); self.wa=w; w.set_has_window(1);

  i=gtk.Image(); self.seti(i,self.skind+"main.png"); i.show(); self.npu(w,i,0,0); self.i_main=i;
  i=gtk.Image(); self.seti(i,self.skind+"titbar.png"); i.show(); self.npu(w,i,0,0); self.i_titbar=i;
#  i=gtk.Image(); self.seti(i,self.skind+"clubar.png"); i.show(); self.npu(w,i,10*2,22*2); self.i_clubar=i;
  i=gtk.Image(); self.seti(i,self.skind+"numB.png"); i.show(); self.npu(w,i,2*(48-12),2*26); self.i_num0=i;
  i=gtk.Image(); self.seti(i,self.skind+"numB.png"); i.show(); self.npu(w,i,2*48,2*26); self.i_num1=i;
  i=gtk.Image(); self.seti(i,self.skind+"numB.png"); i.show(); self.npu(w,i,2*60,2*26); self.i_num2=i;
  i=gtk.Image(); self.seti(i,self.skind+"numB.png"); i.show(); self.npu(w,i,2*78,2*26); self.i_num3=i;
  i=gtk.Image(); self.seti(i,self.skind+"numB.png"); i.show(); self.npu(w,i,2*90,2*26); self.i_num4=i;

  i=self.nbi(self.skind+"clubar.png"); self.npu(w,i,10*2,22*2); i.connect("button_press_event",self.change_skinR); self.b_clubar=i;
#  i.set_allocation(gtk.gdk.Rectangle(0,0,16,86))
  wh=i.get_child().get_allocation()
  x=wh.width; y=wh.height
  print "clubar: "+str(x)+","+str(y)
#  print "clubar_fallback"
  if(x<=1 and y<=1): self.seti(i.get_child(),self.skind+"clubar_fallback.png");

  ox=32; oy=176
  i=self.nbi(self.skind+"prev.png"); self.npu(w,i,ox,oy); i.connect("button_press_event",self.prev); self.b_prev=i;
  i=self.nbi(self.skind+"play.png"); self.npu(w,i,ox+23*2,oy); i.connect("button_press_event",self.play); self.b_play=i;
  i=self.nbi(self.skind+"pause.png"); self.npu(w,i,ox+23*4,oy); i.connect("button_press_event",self.playpause); self.b_playpause=i;
  i=self.nbi(self.skind+"stop.png"); self.npu(w,i,ox+23*6,oy); i.connect("button_press_event",self.stop); self.b_stop=i;
  i=self.nbi(self.skind+"next.png"); self.npu(w,i,ox+23*8,oy); i.connect("button_press_event",self.next); self.b_next=i;
  i=self.nbi(self.skind+"eject.png"); self.npu(w,i,272,oy+2); i.connect("button_press_event",self.eject); self.b_eject=i;

  i=self.nbi(self.skind+"shu.png"); self.npu(w,i,420-46*2,178); i.connect("button_press_event",self.shu); self.b_shu=i;
  i=self.nbi(self.skind+"rep.png"); self.npu(w,i,420,178); i.connect("button_press_event",self.rep); self.b_rep=i;
  i=self.nbi(self.skind+"eq.png"); self.npu(w,i,242*2-23*2,58*2); i.connect("button_press_event",self.eq_showhide); self.b_eq=i;
  i=self.nbi(self.skind+"pl.png"); self.npu(w,i,242*2,58*2); i.connect("button_press_event",self.playlist_showhide); self.b_pl=i;

  i=self.nbi(self.skind+"b_mini.png"); self.npu(w,i,244*2,3*2); i.connect("button_press_event",self.iconify); self.b_mini=i;
  i=self.nbi(self.skind+"b_maxi.png"); self.npu(w,i,254*2,3*2); i.connect("button_press_event",self.toggle_fs); self.b_maxi=i;
  i=self.nbi(self.skind+"b_close.png"); self.npu(w,i,264*2,3*2); i.connect("button_press_event",self.close); self.b_close=i;
  i=self.nbi(self.skind+"b_info.png"); self.npu(w,i,246*2,87*2); i.connect("button_press_event",self.info); self.b_info=i;
  i=self.nbi(self.skind+"b_app.png"); self.npu(w,i,6*2,3*2); i.connect("button_press_event",self.change_skin); self.b_app=i;

  i=self.nbi(self.skind+"mono.png"); self.npu(w,i,212*2,41*2); self.b_mono=i;
  i=self.nbi(self.skind+"ster2.png"); self.npu(w,i,239*2,41*2); self.b_ster=i;

  i=self.nbi(self.skind+"posbar.png"); self.npu(w,i,32,144); i.connect("button_press_event",self.pb1_click); self.eb_1=i;
  i=self.nbi(self.skind+"posha.png"); self.npu(w,i,32,144); self.eb_3=i;

  i=self.nbi(self.skind+"vol_27.png"); self.npu(w,i,107*2,114); i.connect("button_press_event",self.pb2_click); self.eb_2=i;
  i=self.nbi(self.skind+"volha.png"); self.npu(w,i,107*2,116); self.eb_4=i;

  i=self.nbi(self.skind+"bal_14.png"); self.npu(w,i,177*2,114); self.eb_5=i;
  i=self.nbi(self.skind+"balha.png"); self.npu(w,i,177*2+2*((38-14)*14/28),116); self.eb_6=i;

  if(self.id=="n900"): fs1=14; fs2=30
  else: fs1=10; fs2=18

  i=gtk.Entry(1); i.set_has_frame(0); i.set_max_length(128); self.l_listname=i;
  i=self.nbl(w,"",533-221-6-8-10,69-53,220+6+5,52); i.set_alignment(0,0);
#  i.set_selectable(1);
  self.l_curname=i
  fo=pango.FontDescription("sans "+str(fs1));
#  fo.set_weight(700);
  i.modify_font(fo)
  i=self.nbl(w,"",34-6,16,220+3,85); i.set_alignment(1,0); self.l_bitrate=i;	i.modify_font(pango.FontDescription("sans "+str(fs1)));
  i=self.nbl(w,"",26-6,16,308+3,85); i.set_alignment(1,0); self.l_freq=i;	i.modify_font(pango.FontDescription("sans "+str(fs1)));
  i=self.nbl(w,"--",40,32-6,44+6,46+3); i.set_alignment(0.5,0); self.l_state=i;	i.modify_font(pango.FontDescription("sans "+str(fs2)));
  i=self.nbl(w,"00:00",60+10,32-6,95+26-8,48+3); i.set_alignment(0.5,0); self.l_time=i;	i.modify_font(pango.FontDescription("sans "+str(fs2)));
  i=self.nbl(w,"",53,16,95+48,50+36+4); i.set_alignment(0.5,0); self.l_ttime=i;i.modify_font(pango.FontDescription("sans "+str(fs1)));
  i=self.nbl(w,"",53,16,95+48,50+36+12+4); i.set_alignment(0.5,0); self.l_chan=i;i.modify_font(pango.FontDescription("sans "+str(fs1)));

  self.grabset_cols()

  if(not(os.path.isfile(self.skind+"main.png"))): self.change_skin2(None)

  w.show(); self.w0.add(w);

  self.pb_1=gtk.ProgressBar(); self.pb_2=gtk.ProgressBar()

  # prepare songlist
  self.ts = gtk.ListStore(gobject.TYPE_STRING, gobject.TYPE_INT, gobject.TYPE_INT)
  self.tv = gtk.TreeView(self.ts)
#  c=gtk.TreeViewColumn("Index", gtk.CellRendererText(), text=0); c.set_visible(0);  self.tv.append_column(c)
  c=gtk.TreeViewColumn("Name", gtk.CellRendererText(), text=0, weight=1); c.set_sizing(gtk.TREE_VIEW_COLUMN_FIXED)
  self.tv.append_column(c)
#  c=gtk.TreeViewColumn("Type", gtk.CellRendererText(), text=2); c.set_visible(0); self.tv.append_column(c)
  self.tv.set_headers_visible(False)
  self.tv.show(); self.tv.connect('button-press-event' , self.tv_click)

  self.sw = gtk.ScrolledWindow(); self.sw.set_size_request(200,-1); self.sw.add(self.tv)
  self.sw.set_policy(gtk.POLICY_ALWAYS, gtk.POLICY_ALWAYS)

  if(self.id=='n900' or self.id=='n8x0'):
   self.w1 = gtk.Window(gtk.WINDOW_POPUP); self.ww=800; self.wh=480
   self.w1.fullscreen()
  else:
   self.w1 = gtk.Window(gtk.WINDOW_TOPLEVEL);
  self.w1.set_default_size(self.ww,self.wh)
  self.w1.set_border_width(0)
  self.w1.set_property("allow-shrink",False)

  inav2=gtk.VBox();
  i=self.nb("[x]", "cancel"); i.show(); i.connect("clicked", self.playlist_showhide, None); inav2.pack_start(i);
  i=self.nb("mrl", "mrl"); i.show(); i.connect("clicked", self.mrl, None, ""); inav2.pack_start(i);
  i=self.nb(self.l01, "shu"); i.show(); i.connect("clicked", self.shu, None); inav2.pack_start(i);
  i=self.nb(self.l05, "sloacti"); i.show(); i.connect("clicked", self.sloacti, None); inav2.pack_start(i);
  i=self.nb(self.l04, "cquit"); i.show(); i.connect("clicked", self.quitc, None); inav2.pack_start(i);
  i=self.nb(self.l03, "cconn"); i.show(); i.connect("clicked", self.connectto, None); inav2.pack_start(i);
  inav2.show();
  inav=gtk.VBox();
  i=self.nb("..", "gopare"); i.show(); i.connect("clicked", self.go_parent, None); inav.pack_start(i);
  i=self.nb(self.l19, "gocur"); i.show(); i.connect("clicked", self.go_cur, None); inav.pack_start(i);
  i=self.nb(self.l10, "prev"); i.show(); i.connect("clicked", self.prev, None); inav.pack_start(i);
  i=self.nb(self.l15, "pause"); i.show(); i.connect("clicked", self.playpause, None); inav.pack_start(i);
  i=self.nb(self.l16, "stop"); i.show(); i.connect("clicked", self.stop, None); inav.pack_start(i);
  i=self.nb(self.l14, "next"); i.show(); i.connect("clicked", self.next, None); inav.pack_start(i);
  inav.show();

  if(self.id=='n900' or self.id=='n8x0'): l=gtk.Label("      "); l.show(); # spacer
  else: l=gtk.Label("")

  b=gtk.HBox();
  b.pack_start(inav2,0,1);
  b.pack_start(inav,0,1);
  b.pack_start(self.sw,1,1);
  b.pack_start(l,0,0);
  self.sw.show()
  self.w1.add(b); b.show();

  self.w1.realize(); #self.w1.show();

  self.w1.connect("key-press-event", self.key_press_event)
  self.w1.window.property_change(gtk.gdk.atom_intern("_HILDON_ZOOM_KEY_ATOM"), gtk.gdk.atom_intern("INTEGER"), 32, gtk.gdk.PROP_MODE_REPLACE, [1]);
  self.w1.connect("delete_event", self.playlist_showhide); self.w0.connect("destroy", self.playlist_showhide)
  #self.w1.hide();

  self.mw_eq()

#####///////////#
 def mw_eq(self):
  if(self.id=='n900' or self.id=='n8x0'):
   self.w2 = gtk.Window(gtk.WINDOW_POPUP); self.ww=800; self.wh=480
   self.w2.fullscreen()
  else: self.w2 = gtk.Window(gtk.WINDOW_TOPLEVEL);
  self.w2.set_default_size(self.ww,self.wh)
  self.w2.set_title("oscp - eq")
  self.w2.set_border_width(0)
  self.w2.set_property("allow-shrink",False)

  b=gtk.HBox(1,0);
#  i=gtk.Label(" "); i.show(); b.pack_start(i,0,1);
  bb=gtk.VBox(); bb.show();
  i=self.nb("[x]", "cancel"); i.show(); i.connect("clicked", self.eq_showhide, None); bb.pack_start(i,1,1)
  tb=gtk.ToggleButton("eq"); tb.set_active(self.eq); tb.show(); bb.pack_start(tb,1,1); tb.connect("clicked", self.eq_tog); self.tb_eq=tb
  tb=gtk.ToggleButton("flngr"); tb.set_active(self.eff&1); tb.show(); bb.pack_start(tb,1,1); tb.connect("clicked", self.eff_flanger_tog); self.tb_eff_flanger=tb
  tb=gtk.ToggleButton("Rwax"); tb.set_active(self.eff&2); tb.show(); bb.pack_start(tb,1,1); tb.connect("clicked", self.eff_earwax_tog); self.tb_eff_earwax=tb
  tb=gtk.ToggleButton("rvrb"); tb.set_active(self.eff&8); tb.show(); bb.pack_start(tb,1,1); tb.connect("clicked", self.eff_reverb_tog); self.tb_eff_reverb=tb
  tb=gtk.ToggleButton("ctrst"); tb.set_active(self.eff&4); tb.show(); bb.pack_start(tb,1,1); tb.connect("clicked", self.eff_contrast_tog); self.tb_eff_contrast=tb
  tb=gtk.ToggleButton("ovdrv"); tb.set_active(self.eff&16);
  #tb.show(); bb.pack_start(tb,1,1);
  tb.connect("clicked", self.eff_overdrive_tog); self.tb_eff_overdrive=tb
  tb=gtk.ToggleButton("k'oke"); tb.set_active(self.eff&32); tb.show(); bb.pack_start(tb,1,1); tb.connect("clicked", self.eff_karaoke_tog); self.tb_eff_karaoke=tb
  b.pack_start(bb,1,1);
  l,i,bb=self.nsli(self.eq60,"1","60"); self.s_eq60=i; b.pack_start(bb,0,1);# l.connect("clicked",self.rsli,i)
  l,i,bb=self.nsli(self.eq170,"2","170"); self.s_eq170=i; b.pack_start(bb,0,1);
  l,i,bb=self.nsli(self.eq310,"3","310"); self.s_eq310=i; b.pack_start(bb,0,1);
  l,i,bb=self.nsli(self.eq600,"4","600"); self.s_eq600=i; b.pack_start(bb,0,1);
  l,i,bb=self.nsli(self.eq1k,"5","1k"); self.s_eq1k=i; b.pack_start(bb,0,1);
  l,i,bb=self.nsli(self.eq3k,"6","3k"); self.s_eq3k=i; b.pack_start(bb,0,1);
  l,i,bb=self.nsli(self.eq6k,"7","6k"); self.s_eq6k=i; b.pack_start(bb,0,1);
  l,i,bb=self.nsli(self.eq12k,"8","12k"); self.s_eq12k=i; b.pack_start(bb,0,1);
  l,i,bb=self.nsli(self.eq14k,"9","14k"); self.s_eq14k=i; #b.pack_start(bb,0,1);
  l,i,bb=self.nsli(self.eq16k,"10","16k"); self.s_eq16k=i; b.pack_start(bb,0,1);
  l,i,bb=self.nsli(self.eq22k,"11","22k"); self.s_eq22k=i; #b.pack_start(bb,0,1);
  b.show();
  self.w2.add(b);

  self.w2.realize(); #self.w1.show();

  self.w2.connect("key-press-event", self.key_press_event)
  self.w2.window.property_change(gtk.gdk.atom_intern("_HILDON_ZOOM_KEY_ATOM"), gtk.gdk.atom_intern("INTEGER"), 32, gtk.gdk.PROP_MODE_REPLACE, [1]);
  self.w2.connect("delete_event", self.eq_showhide); self.w0.connect("destroy", self.eq_showhide)
  #self.w2.hide();

 def rsli(self,widget,i): a0=i.get_adjustment(); a0.set_value(0); a0.emit("changed")
 def nsli(self,val,id,lab):
  adj=gtk.Adjustment(value=val, lower=self.eq_min, upper=self.eq_max); i=gtk.VScale(adj); i.show();
  i.set_update_policy(gtk.UPDATE_DELAYED)
  adj.connect("value_changed", self.eq_ch, id);
#  if(self.id!='n900'):
  i.set_inverted(1)
  i.set_value_pos(gtk.POS_BOTTOM);
  bb=gtk.VBox(); bb.show();
#  l=gtk.Label("\n"+lab+"\n"); l.show();
  l=self.nb(lab,""); l.show();
  bb.pack_start(l,0,1); bb.pack_start(i,1,1);
  l.connect("clicked",self.rsli,i)
  return [l,i,bb]

 def eq_tog(self, tb):
  if(self.eq_tog_ign==1): return
  self.say("TOGGLE EQ")
#  if(self.tb_eq_tog.get_active()): self.say("EQ 1")
#  else: self.say("EQ 0")
#  print "eq_tog, ign:"+str(self.eq_tog_ign)
#  if(not(self.eq_tog_ign)): print "eq_tog said EQ"; self.say("EQ")
#  self.eq_tog_ign=0
 def eq_ch(self, adj, eqn):
  v=adj.get_value(); #v2=math.pow(10.0, v);
#  print("eq_ch: EQ"+eqn+" "+str(v))
  self.say("EQ"+eqn+" "+str(v))
 def update_eq(self):
#  print "update_eq: "+str(self.eq)
  self.eq_tog_ign=1
  if(self.eq==0): self.tb_eq.set_active(0)
  else: self.tb_eq.set_active(1)
  a=gtk.Adjustment(value=self.eq60, lower=self.eq_min, upper=self.eq_max); self.s_eq60.set_adjustment(a); a.connect("value_changed", self.eq_ch, "1");
  a=gtk.Adjustment(value=self.eq170, lower=self.eq_min, upper=self.eq_max); self.s_eq170.set_adjustment(a); a.connect("value_changed", self.eq_ch, "2");
  a=gtk.Adjustment(value=self.eq310, lower=self.eq_min, upper=self.eq_max); self.s_eq310.set_adjustment(a); a.connect("value_changed", self.eq_ch, "3");
  a=gtk.Adjustment(value=self.eq600, lower=self.eq_min, upper=self.eq_max); self.s_eq600.set_adjustment(a); a.connect("value_changed", self.eq_ch, "4");
  a=gtk.Adjustment(value=self.eq1k, lower=self.eq_min, upper=self.eq_max); self.s_eq1k.set_adjustment(a); a.connect("value_changed", self.eq_ch, "5");
  a=gtk.Adjustment(value=self.eq3k, lower=self.eq_min, upper=self.eq_max); self.s_eq3k.set_adjustment(a); a.connect("value_changed", self.eq_ch, "6");
  a=gtk.Adjustment(value=self.eq6k, lower=self.eq_min, upper=self.eq_max); self.s_eq6k.set_adjustment(a); a.connect("value_changed", self.eq_ch, "7");
  a=gtk.Adjustment(value=self.eq12k, lower=self.eq_min, upper=self.eq_max); self.s_eq12k.set_adjustment(a); a.connect("value_changed", self.eq_ch, "8");
  a=gtk.Adjustment(value=self.eq14k, lower=self.eq_min, upper=self.eq_max); self.s_eq14k.set_adjustment(a); a.connect("value_changed", self.eq_ch, "9");
  a=gtk.Adjustment(value=self.eq16k, lower=self.eq_min, upper=self.eq_max); self.s_eq16k.set_adjustment(a); a.connect("value_changed", self.eq_ch, "10");
  a=gtk.Adjustment(value=self.eq22k, lower=self.eq_min, upper=self.eq_max); self.s_eq22k.set_adjustment(a); a.connect("value_changed", self.eq_ch, "11");
  self.eq_tog_ign=0

 def eff_flanger_tog(self, tb):
  if(self.eff_tog_ign==1): return
  self.say("TOGGLE FLANGER")
 def eff_earwax_tog(self, tb):
  if(self.eff_tog_ign==1): return
  self.say("TOGGLE EARWAX")
 def eff_contrast_tog(self, tb):
  if(self.eff_tog_ign==1): return
  self.say("TOGGLE CONTRAST")
 def eff_reverb_tog(self, tb):
  if(self.eff_tog_ign==1): return
  self.say("TOGGLE REVERB")
 def eff_overdrive_tog(self, tb):
  if(self.eff_tog_ign==1): return
  self.say("TOGGLE OVERDRIVE")
 def eff_karaoke_tog(self, tb):
  if(self.eff_tog_ign==1): return
  self.say("TOGGLE KARAOKE")
 def update_eff(self):
  self.eff_tog_ign=1
  if(self.eff&1): self.tb_eff_flanger.set_active(1)
  else: self.tb_eff_flanger.set_active(0)
  if(self.eff&2): self.tb_eff_earwax.set_active(1)
  else: self.tb_eff_earwax.set_active(0)
  if(self.eff&4): self.tb_eff_contrast.set_active(1)
  else: self.tb_eff_contrast.set_active(0)
  if(self.eff&8): self.tb_eff_reverb.set_active(1)
  else: self.tb_eff_reverb.set_active(0)
  if(self.eff&16): self.tb_eff_overdrive.set_active(1)
  else: self.tb_eff_overdrive.set_active(0)
  if(self.eff&32): self.tb_eff_karaoke.set_active(1)
  else: self.tb_eff_karaoke.set_active(0)
  self.eff_tog_ign=0

#####//////////////////#
 def init_iconset(self):
  self.l20="[0]";self.l21="[1]";self.l22="[2]";self.l23="[3]";self.l24="[4]";self.l25="[5]";
  self.l26="[6]";self.l27="[7]";self.l28="[8]";self.l29="[9]";self.l30="m";self.l31="[F]";
  self.l32="V";self.l33="?";self.l34="I";self.l35="FS";self.l36="[O]";self.l37="Eq"
  self.l38="LOVE"; self.l39="Sc";

  self.l0="|";  self.l1="<";  self.l2=">";  self.l3="=";  self.l4="[]"  # |, <, >, =, []
  self.l5="/\\";  self.l6="\\/" # /\\ \\/
  self.l00="R"; self.l01="S"; self.l02="[x]"; self.l03="CC"; self.l04="CQ";
  self.l05="CS"; # Rep, Shu, [x], conn, cquit, sloacti
  self.l10="|<"; self.l11="<<"; self.l12="||"; self.l13=">>"; self.l14=">|"; self.l15="|>";
  self.l16="[]";
  self.l17=self.l5+self.l5; self.l18=self.l6+self.l6; self.l19=self.l1+self.l2

  if(self.iconset==0): return
  # buttons (icons)
  if(self.id=='pc'):
   self.l0=u"\u25ae"; self.l1=u"\u25c0"; self.l2=u"\u25b6"; self.l3="="; self.l4=u"\u25a0";
   self.l5=u"\u25b2"; self.l6=u"\u25bc"
   self.l00="R"; self.l01="S"; self.l02=u"\u2716"; self.l03=u"\u2706"; self.l04=u"\u2612";
   self.l05=u"\u2699";
   self.l10=self.l0+self.l1; self.l11=self.l1+self.l1; self.l12=self.l0+self.l0;
   self.l13=self.l2+self.l2; self.l14=self.l2+self.l0; self.l15=u"\u25b6"; self.l16=u"\u25a0";
   self.l17=self.l5+self.l5; self.l18=self.l6+self.l6; self.l19=self.l1+self.l2
  elif(self.id=='n900' or self.id=='n8x0'):
   self.l0=u"\u25aa"; self.l1=u"\u25c4"; self.l2=u"\u25ba"; self.l3="="; self.l4=u"\u2587";
   self.l5=u"\u25b2"; self.l6=u"\u25bc"
   #self.l5=u"\u2191"; self.l6=u"\u2193"
   self.l10=self.l0+self.l1; self.l11=self.l1+self.l1; self.l12=self.l0+self.l0; self.l13=self.l2+self.l2; self.l14=self.l2+self.l0; self.l15=self.l2; self.l16=self.l4;
   self.l17=self.l5+self.l5; self.l18=self.l6+self.l6; self.l19=self.l1+self.l2


#####//////////////////#
 def setup_window(self):
  self.w0 = gtk.Window(gtk.WINDOW_TOPLEVEL);
  if(self.ww<=0 or self.wh<=0): self.ww=self.mm(self.defsize)*8; self.wh=self.mm(self.defsize)*7
#  print "sw: "+str(self.wh)
  self.w0.set_default_size(self.ww,self.wh)
  self.w0.set_border_width(1)
  self.w0.connect("delete_event", self.delete_event); self.w0.connect("destroy", self.destroy)

  #settings = gtk.settings_get_default(); settings.props.gtk_button_images = True

  border_width=0
  self.b_vid = self.nb(self.l32, ""); self.b_vid.connect("clicked", self.vid, None)
  self.b_rep = self.nb(self.l00, ""); self.b_rep.connect("clicked", self.rep, None)
  self.b_shu = self.nb(self.l01, ""); self.b_shu.connect("clicked", self.shu, None)
  self.b_prev = self.nb(self.l10, "prev"); self.b_prev.connect("clicked", self.prev, None)
  self.b_rwnd = self.nb(self.l11, "rwnd"); self.b_rwnd.connect("clicked", self.rwnd, None)
  self.b_playpause = self.nb(self.l15, "pause"); self.b_playpause.connect("clicked", self.playpause, None)
#  self.i_play=gtk.Image(); self.i_play.set_from_stock(gtk.STOCK_MEDIA_PLAY, gtk.ICON_SIZE_BUTTON);
#  self.i_pause=gtk.Image(); self.i_pause.set_from_stock(gtk.STOCK_MEDIA_PAUSE, gtk.ICON_SIZE_BUTTON);
  #self.b_pause = self.nb(self.l12, gtk.STOCK_MEDIA_PAUSE); self.b_pause.connect("clicked", self.pause, None)
  self.b_ffwd = self.nb(self.l13, "ffwd"); self.b_ffwd.connect("clicked", self.ffwd, None)
  self.b_next = self.nb(self.l14, "next"); self.b_next.connect("clicked", self.next, None)
  #self.b_play = self.nb(self.l15, "play"); self.b_play.connect("clicked", self.play, None)
  self.b_stop = self.nb(self.l16, "stop"); self.b_stop.connect("clicked", self.stop, None)

  self.pb_1 = gtk.ProgressBar(adjustment=None) # song progress bar
  self.pb_1.set_orientation(gtk.PROGRESS_LEFT_TO_RIGHT); self.pb_1.show()
  self.eb_1 = gtk.EventBox(); self.eb_1.add(self.pb_1)
  self.eb_1.connect("button_press_event", self.pb1_click)

  self.pb_2 = gtk.ProgressBar(adjustment=None) # volume slider
  self.pb_2.set_orientation(gtk.PROGRESS_LEFT_TO_RIGHT); self.pb_2.show()
  self.eb_2 = gtk.EventBox(); self.eb_2.add(self.pb_2)
  self.eb_2.connect("button_press_event", self.pb2_click)

  #self.l_listname = gtk.Label("[listname]"); self.l_listname.set_selectable(1); self.l_listname.set_line_wrap(1);
  #self.l_curname = gtk.Label("[curname]"); self.l_curname.set_selectable(1); self.l_curname.set_line_wrap(1);
  #2.6+ self.l_listname.single_line_mode(1); self.l_curname.single_line_mode(1);
  self.l_listname = gtk.Entry(1); self.l_listname.set_has_frame(0); self.l_listname.set_max_length(128);
  self.set_ln("[listname]");
  self.l_curname = gtk.Entry(1); self.l_curname.set_has_frame(0); self.l_curname.set_max_length(128);
  self.set_cn("[curname]");
  self.l_time = gtk.Label("00:00");
  self.l_ttime = gtk.Label("");
  self.l_freq = gtk.Label("x kHz");
  self.l_bitrate = gtk.Label("x kbps");
  self.l_chan = gtk.Label("");
  self.l_state = gtk.Label("--");
  self.b_volD = self.nb("v-", "volD"); self.b_volD.connect("clicked", self.volD, None)
  self.b_volI = self.nb("v+", "volI"); self.b_volI.connect("clicked", self.volI, None)
  self.l_vol = gtk.Label("Vol ");
  self.b_sloacti = self.nb(self.l05, "sloacti"); self.b_sloacti.connect("clicked", self.sloacti, None)
  self.b_quitc = self.nb(self.l04, "cquit"); self.b_quitc.connect("clicked", self.quitc, None)
  self.b_conn = self.nb(self.l03, "cconn"); self.b_conn.connect("clicked", self.connectto, None)
  self.b_x = self.nb(self.l02, "quit"); self.b_x.connect("clicked", self.close, None)
  self.b_help = self.nb(self.l33, "help"); self.b_help.connect("clicked", self.help, None)
  self.b_info = self.nb(self.l34, "info"); self.b_info.connect("clicked", self.info, None)
  self.b_maxi = self.nb(self.l35, "maxi"); self.b_maxi.connect("clicked", self.toggle_fs)
  self.b_opts = self.nb(self.l36, "opts"); self.b_opts.connect("clicked", self.opts, None)
  self.b_eq = self.nb(self.l37, "eq"); self.b_eq.connect("clicked", self.eq_showhide, None)
  self.b_sclove = self.nb(self.l38, ""); self.b_sclove.connect("clicked", self.sc_love, None)
  self.b_sctog = self.nb(self.l39, ""); self.b_sctog.connect("clicked", self.sc_tog, None)
  

  self.b_lfSH = self.nb(self.l31, "morebuttons"); self.b_lfSH.connect("clicked", self.favSH)
  self.b_lfR = self.nb(self.l30, ""); self.b_lfR.connect("clicked", self.favR, None)
  self.b_lf0 = self.nb(self.l20, ""); self.b_lf0.connect("clicked", self.loadfav, 0, None)
  self.b_lf1 = self.nb(self.l21, ""); self.b_lf1.connect("clicked", self.loadfav, 1, None)
  self.b_lf2 = self.nb(self.l22, ""); self.b_lf2.connect("clicked", self.loadfav, 2, None)
  self.b_lf3 = self.nb(self.l23, ""); self.b_lf3.connect("clicked", self.loadfav, 3, None)
  self.b_lf4 = self.nb(self.l24, ""); self.b_lf4.connect("clicked", self.loadfav, 4, None)
  self.b_lf5 = self.nb(self.l25, ""); self.b_lf5.connect("clicked", self.loadfav, 5, None)
  self.b_lf6 = self.nb(self.l26, ""); self.b_lf6.connect("clicked", self.loadfav, 6, None)
  self.b_lf7 = self.nb(self.l27, ""); self.b_lf7.connect("clicked", self.loadfav, 7, None)
  self.b_lf8 = self.nb(self.l28, ""); self.b_lf8.connect("clicked", self.loadfav, 8, None)
  self.b_lf9 = self.nb(self.l29, ""); self.b_lf9.connect("clicked", self.loadfav, 9, None)

  self.box_lnavMB = gtk.HBox(0, 0); self.box_lnavMB.set_border_width(0) #list nav
  self.box_lnav2 = gtk.VBox(0, 0); self.box_lnav2.set_border_width(0) #list nav
  self.box_lnav3 = gtk.VBox(0, 0); self.box_lnav3.set_border_width(0) #list nav
  self.box_lnav4 = gtk.VBox(0, 0); self.box_lnav4.set_border_width(0) #list nav
  self.box_lnav5 = gtk.VBox(0, 0); self.box_lnav5.set_border_width(0) #list nav
  self.box_lnav6 = gtk.VBox(0, 0); self.box_lnav5.set_border_width(0) #list nav

  self.b_go_root = self.nb("/", "goroot"); self.b_go_root.connect("clicked", self.go_root, None)
  self.b_go_parent = self.nb("..", "gopare"); self.b_go_parent.connect("clicked", self.go_parent, None)
  self.b_mrl = self.nb("mrl", "mrl"); self.b_mrl.connect("clicked", self.mrl, None, "")
  self.b_go_top = self.nb(self.l17, "gotop"); self.b_go_top.connect("clicked", self.go_top, None)
  self.b_go_pgup = self.nb(self.l5, "gopgup"); self.b_go_pgup.connect("clicked", self.go_pgup, None)
  self.b_go_cur = self.nb(self.l19, "gocur"); self.b_go_cur.connect("clicked", self.go_cur, None)
  self.b_go_pgdn = self.nb(self.l6, "gopgdn"); self.b_go_pgdn.connect("clicked", self.go_pgdn, None)
  self.b_go_end = self.nb(self.l18, "goend"); self.b_go_end.connect("clicked", self.go_end, None)
  self.box_lnav = gtk.VBox(0, 0); self.box_lnav.set_border_width(0) #list nav

  gtk.Tooltips().set_tip(self.b_prev, "previous");
  gtk.Tooltips().set_tip(self.b_rwnd, "seek backward");
  #gtk.Tooltips().set_tip(self.b_pause, "pause");
  gtk.Tooltips().set_tip(self.b_ffwd, "seek forward");
  gtk.Tooltips().set_tip(self.b_next, "next");
  gtk.Tooltips().set_tip(self.b_playpause, "play/pause");
  #gtk.Tooltips().set_tip(self.b_play, "play");
  gtk.Tooltips().set_tip(self.b_stop, "stop");
  gtk.Tooltips().set_tip(self.b_volD, "decrease volume");
  gtk.Tooltips().set_tip(self.b_volD, "increase volume");
  gtk.Tooltips().set_tip(self.b_sloacti, "spawn local oscp and connect to it");
  gtk.Tooltips().set_tip(self.b_quitc, "quit core");
  gtk.Tooltips().set_tip(self.b_conn, "connect to core");
  gtk.Tooltips().set_tip(self.b_x, "quit remote");
  gtk.Tooltips().set_tip(self.b_go_root, "go to root metadir");
  gtk.Tooltips().set_tip(self.b_go_parent, "go to parent dir");
  gtk.Tooltips().set_tip(self.b_mrl, "make recursive list");
  gtk.Tooltips().set_tip(self.b_go_top, "scroll to top");
  gtk.Tooltips().set_tip(self.b_go_pgup, "scroll one page up");
  gtk.Tooltips().set_tip(self.b_go_cur, "scroll to currently playing file");
  gtk.Tooltips().set_tip(self.b_go_pgdn, "scroll one page down");
  gtk.Tooltips().set_tip(self.b_go_end, "scroll to end");
  gtk.Tooltips().set_tip(self.b_lfR, "memorize dir/list into fav");
  gtk.Tooltips().set_tip(self.b_lfSH, "show more buttons");
  gtk.Tooltips().set_tip(self.b_info, "show info");
  gtk.Tooltips().set_tip(self.b_maxi, "toggle fullscreen");
  gtk.Tooltips().set_tip(self.b_opts, "show options");
  gtk.Tooltips().set_tip(self.b_x, "quit");
  gtk.Tooltips().set_tip(self.b_sclove, "add track to favs on last.fm");
  gtk.Tooltips().set_tip(self.b_sctog, "toggle scrobbling");

  sep="  "
  self.ls1 = gtk.Label(sep);
  self.ls2 = gtk.Label(sep);
  self.ls3 = gtk.Label(sep);
  self.ls4 = gtk.Label(sep);
  self.ls5 = gtk.Label(sep);

  self.ts = gtk.ListStore(gobject.TYPE_STRING, gobject.TYPE_INT, gobject.TYPE_INT)
  self.tv = gtk.TreeView(self.ts)
  self.tv.set_properties("fixed-height-mode",1)

#  self.tv.set_model(None)
#  self.tv.get_model().set_default_sort_func(lambda *unused: 0) # <-- can also use None but that is slower!
#  self.tv.get_model().set_sort_column_id(-1, gtk.SORT_ASCENDING)

  c=gtk.TreeViewColumn("Name", gtk.CellRendererText(), text=0, weight=1); c.set_sizing(gtk.TREE_VIEW_COLUMN_FIXED)
  self.tv.append_column(c)

  self.tv.set_headers_visible(False)
  self.tv.show(); self.tv.connect('button-press-event' , self.tv_click)

  self.sw = gtk.ScrolledWindow(); self.sw.set_size_request(200,-1); self.sw.add(self.tv)
  self.sw.set_policy(gtk.POLICY_NEVER, gtk.POLICY_AUTOMATIC)
#  self.sw.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
#  self.sw.set_policy(gtk.POLICY_ALWAYS, gtk.POLICY_ALWAYS)

  self.box00 = gtk.HBox(0, 0); self.box00.set_border_width(0) #main box h
  self.box0 = gtk.VBox(0, 0); self.box0.set_border_width(0) #main box v
  self.box1 = gtk.HBox(0, 0); self.box1.set_border_width(border_width) #listname
  self.box2 = gtk.HBox(0, 0); self.box2.set_border_width(border_width) #curname
  self.box3 = gtk.HBox(0, 4); self.box3.set_border_width(border_width) #time, ttime, freq etc
  self.box4 = gtk.VBox(0, 0); self.box4.set_border_width(border_width) #buttons
  self.box5 = gtk.HBox(0, 0); self.box5.set_border_width(border_width) #buttons2
  self.boxl = gtk.HBox(0, 0); self.boxl.set_border_width(border_width) #list

  #packing time
  #self.boxl.pack_start(self.box_lnav,0,1); self.box_lnav.show()
  self.boxl.pack_start(self.sw,1,1); self.sw.show();
  if(self.id!='pc'): self.boxl.pack_start(self.ls4,0,0); self.ls4.show()

  self.box1.pack_start(self.l_listname,1,1); self.l_listname.show()
  self.box2.pack_start(self.l_curname,1,1); self.l_curname.show()

  self.box3.pack_start(self.ls5,0,0); self.ls5.show()
  self.box3.pack_start(self.l_state,0,0); self.l_state.show()
  #self.box3.pack_start(self.l_time,0,0); self.l_time.show()
  #self.box3.pack_start(self.l_ttime,0,0); self.l_ttime.show()
  self.box3.pack_start(self.eb_1,1,1); self.eb_1.show()
  self.box3.pack_start(self.l_freq,0,0); self.l_freq.show()
  self.box3.pack_start(self.l_chan,0,0); self.l_chan.show()
  self.box3.pack_start(self.l_bitrate,0,0); self.l_bitrate.show()
#  self.box3.pack_start(self.b_eq,0,0); self.b_eq.show()
  self.box3.pack_start(self.b_rep,0,0); self.b_rep.show()

  #self.box4.pack_start(self.b_rwnd); self.b_rwnd.show()

#  self.box5.pack_start(self.b_opts); self.b_opts.show()
  self.box5.pack_start(self.ls1); self.ls1.show()
  self.box5.pack_start(self.b_prev); self.b_prev.show()
  self.box5.pack_start(self.b_playpause); self.b_playpause.show()
  self.box5.pack_start(self.b_stop); self.b_stop.show()
  self.box5.pack_start(self.b_next); self.b_next.show()
  #self.box5.pack_start(self.b_pause); self.b_pause.show()
  #self.box5.pack_start(self.b_play); self.b_play.show()
  #self.box4.pack_start(self.b_ffwd); self.b_ffwd.show()
  self.box5.pack_start(self.ls2); self.ls2.show()
  if(self.volume_as_slider==1):
   self.box5.pack_start(self.eb_2,1,1); self.eb_2.show()
  else:
   self.box5.pack_start(self.l_vol); self.l_vol.show()
   self.box5.pack_start(self.b_volD); self.b_volD.show()
   self.box5.pack_start(self.b_volI); self.b_volI.show()
  self.box5.pack_start(self.ls3); self.ls3.show()
  self.box5.pack_start(self.b_sclove,0,0); #self.b_sclove.show()
  self.box5.pack_start(self.b_shu,0,0); self.b_shu.show()

  self.box_lnav.pack_start(self.b_go_parent); self.b_go_parent.show()
  self.box_lnav.pack_start(self.b_go_root); self.b_go_root.show()
  self.box_lnav.pack_start(self.b_lfSH); self.b_lfSH.show()
  self.box_lnav.pack_start(self.b_sloacti); self.b_sloacti.show()
  self.box_lnav.pack_start(self.b_quitc); self.b_quitc.show()
  self.box_lnav.pack_start(self.b_conn); self.b_conn.show()
  self.box_lnav.pack_start(self.b_info); self.b_info.show()

  self.box_lnav2.pack_start(self.b_go_cur); self.b_go_cur.show()
  self.box_lnav2.pack_start(self.b_maxi); self.b_maxi.show()
  self.box_lnav2.pack_start(self.b_lf1); self.b_lf1.show()
  self.box_lnav2.pack_start(self.b_lf2); self.b_lf2.show()
  self.box_lnav2.pack_start(self.b_lf3); self.b_lf3.show()
  self.box_lnav2.pack_start(self.b_lf4); self.b_lf4.show()
  self.box_lnav2.pack_start(self.b_lf5); self.b_lf5.show()
  self.box_lnav3.pack_start(self.b_lfR); self.b_lfR.show()
  self.box_lnav3.pack_start(self.b_mrl); self.b_mrl.show()
  self.box_lnav3.pack_start(self.b_lf6); self.b_lf6.show()
  self.box_lnav3.pack_start(self.b_lf7); self.b_lf7.show()
  self.box_lnav3.pack_start(self.b_lf8); self.b_lf8.show()
  self.box_lnav3.pack_start(self.b_lf9); self.b_lf9.show()
  self.box_lnav3.pack_start(self.b_lf0); self.b_lf0.show()

  self.box_lnav4.pack_start(self.b_go_top); self.b_go_top.show()
  self.box_lnav4.pack_start(self.b_go_pgup); self.b_go_pgup.show()
  self.box_lnav4.pack_start(self.b_go_pgdn); self.b_go_pgdn.show()
  self.box_lnav4.pack_start(self.b_go_end); self.b_go_end.show()
  b=self.nb("", "rwnd"); b.show(); self.box_lnav4.pack_start(b)
  b=self.nb("", "ffwd"); b.show(); self.box_lnav4.pack_start(b)
  self.box_lnav4.pack_start(self.b_help); self.b_help.show()
  b=self.nb("", "chstyle"); b.show(); self.box_lnav4.pack_start(b)

  b=self.nb("", "shu"); b.show(); self.box_lnav5.pack_start(b)
  b=self.nb("", "rep"); b.show(); self.box_lnav5.pack_start(b)
  b=self.nb("", "vid"); b.show(); self.box_lnav5.pack_start(b)
  b=self.nb("", "ok"); b.show(); self.box_lnav5.pack_start(b)
  b=self.nb("", "cancel"); b.show(); self.box_lnav5.pack_start(b)
  b=self.nb("", "volM"); b.show(); self.box_lnav5.pack_start(b)

  self.box_lnav6.pack_start(self.b_x); self.b_x.show()
  self.box_lnav6.pack_start(self.b_eq); self.b_eq.show()
  self.box_lnav6.pack_start(self.b_sctog); self.b_sctog.show()
  self.box_lnav6.pack_start(self.b_vid); self.b_vid.show()
#  self.box_lnav6.pack_start(self.b_rep); self.b_rep.show()
  if(self.volume_as_slider==1):
   self.box_lnav6.pack_start(self.b_volI); self.b_volI.show()
   self.box_lnav6.pack_start(self.b_volD); self.b_volD.show()

  if(self.small==0): self.box0.pack_start(self.box1,0,1); self.box1.show()
  self.box0.pack_start(self.boxl,1,1); self.boxl.show()
  if(self.small==0): self.box0.pack_start(self.box2,0,1); self.box2.show()
  self.box0.pack_start(self.box3,0,1); self.box3.show()
#  self.box0.pack_start(self.box4,0,1); self.box4.show()
  self.box0.pack_start(self.box5,0,1); self.box5.show()

  self.box_lnavMB.pack_start(self.box_lnav6,0,1); self.box_lnav6.show();
#  self.box_lnavMB.pack_start(self.box_lnav5,0,1); self.box_lnav5.show();
#  self.box_lnavMB.pack_start(self.box_lnav4,0,1); self.box_lnav4.show();
  self.box_lnavMB.pack_start(self.box_lnav2,0,1); self.box_lnav2.show();
  self.box_lnavMB.pack_start(self.box_lnav3,0,1); self.box_lnav3.show();
  self.box00.pack_start(self.box_lnavMB,0,1);

  if(self.i_like_buttons): self.i_like_buttons=0; self.favSH(None)
  self.box00.pack_start(self.box_lnav,0,1); self.box_lnav.show()
  self.box00.pack_start(self.box0,1,1); self.box0.show()
  #self.box00.pack_start(self.box4,0,1); self.box4.show()

  self.w0.add(self.box00); self.box00.show();
  #packing end

  self.mw_eq()

 def sc_love(self, widget, data=None): self.say("SCROBLOVE");
 def sc_tog(self, widget, data=None): self.say("SCROBBLER");

 def __init__(self):
  first_time=self.load_conf()
  self.init_style()
  self.init_iconset()

  #gtk.rc_parse("oscp-remote.gtkrc")
  gtk.rc_parse_string(self.local_gtkrc)

  if(self.style_me!=3): self.setup_window()
  else: self.setup_window_wa()

  if(self.fullscreen>0): self.fullscreen=0; self.toggle_fs(None, None)

  self.w0.show() # w0.show_all()
  self.w0.connect("key-press-event", self.key_press_event)
  self.w0.window.property_change(gtk.gdk.atom_intern("_HILDON_ZOOM_KEY_ATOM"), gtk.gdk.atom_intern("INTEGER"), 32, gtk.gdk.PROP_MODE_REPLACE, [1])

#  print "init wxy0: "+str(self.wx)+","+str(self.wy)
#  print "init wwh0: "+str(self.ww)+","+str(self.wh)
  if(self.wx>0 or self.wy>0): self.w0.move(self.wx, self.wy)
  if(self.ww>0 and self.wh>0): self.w0.resize(self.ww, self.wh)
#  self.wx,self.wy=self.w0.get_position()
#  print "init wxy: "+str(self.wx)+","+str(self.wy)

  argc=len(sys.argv)
  if(argc>=3): self.HOST=sys.argv[1]; self.PORT=int(sys.argv[2]); self.save_conf();
#  else: self.load_lasthost()

  if(self.HOST==""): self.HOST="127.0.0.1"
  if(self.PORT<1 or self.PORT>65535): self.PORT=44322
  self.mkconn()

  if(self.id=="n900"):
   os.system("amixer -qc0 cset iface=MIXER,name='Jack Bias Switch' on")
   dp_hsb_fremantle = '/org/freedesktop/Hal/devices/computer_logicaldev_input_1'
   dp_camfocus_fremantle = '/org/freedesktop/Hal/devices/platform_cam_focus'

   from dbus.mainloop.glib import DBusGMainLoop
   import dbus
   dbus.mainloop.glib.DBusGMainLoop(set_as_default=True)
   self.sbus = dbus.SystemBus()
   self.sbus.add_signal_receiver(self.handle_hsb, 'Condition','org.freedesktop.Hal.Device', None, dp_hsb_fremantle)
   self.sbus.add_signal_receiver(self.handle_focus, 'Condition','org.freedesktop.Hal.Device', None, dp_camfocus_fremantle)
   self.mceRequest = self.sbus.get_object('com.nokia.mce', '/com/nokia/mce/request')

  if(first_time==1): self.help(None)

# https://raw.githubusercontent.com/M4rtinK/modrana/master/modules/device_modules/device_n900.py
# self.mceRequest = self.sbus.get_object('com.nokia.mce', '/com/nokia/mce/request')
# self.mceSignal = self.sbus.get_object('com.nokia.mce', '/com/nokia/mce/signal')
# self.mceSignalInterface = dbus.Interface(self.mceSignal, 'com.nokia.mce.signal')
# self.mceSignalInterface.connect_to_signal("display_status_ind", self.screenStateChangedCallback)
# self.log.info("DBUS initialized")
# every ~30s  self.mceRequest.req_display_blanking_pause()
# unlock  self.mceRequest.req_tklock_mode_change('unlocked')

   #the_object = bus.get_object("com.nokia.mce", "/com/nokia/mce/request")
   #the_interface = dbus.Interface(the_object, "com.nokia.mce.request")
   #reply = the_interface.hello()
#dbus-send --system --type=method_call --print-reply
#--dest=com.nokia.mce /com/nokia/mce/request com.nokia.mce.req_display_blanking_pause
#the_interface.Quit()

#   pixbuf = gtk.gdk.pixbuf_new_from_file("/opt/oscp/share/images/main.png")
#   pixmap, mask = pixbuf.render_pixmap_and_mask(); width, height = pixmap.get_size(); del pixbuf
#   self.w0.set_app_paintable(1); self.w0.window.set_back_pixmap(pixmap, 0)
#   x, y = self.b_go_parent.get_size_request(); print str(x)+","+str(y)

 def main(self):
  gtk.main()

if __name__ == "__main__":
 orem = oscp_remote()
 orem.main()

#  pack_start(child, expand=True, fill=True, padding=0)
# expand=True means "I will fight for space"  expand=False means "I don't want more space"
# fill=True means "If I got more space, I will occupy it with my content"
# fill=False means "If I got more space, leave it blank" 

#  gtk.HBox(homogeneous=False, spacing=0)
# homogeneous : If True all children are given equal space allocations.
# spacing : The additional horizontal space between children in pixels
