#!/usr/bin/env python

import sys; import glib; import gobject; import time
#import os #import math #from os.path import expanduser #import random #import socket

class oscp_dbus_listener:
 id=""; focus=0

 def handle_dbus(self, signal, button): print "handle_dbus: "+str(signal)+","+str(button)
 def handle_hpjack(self, signal, button): # proximity?
  try: f=open("/sys/devices/platform/gpio-switch/headphone/state","rb"); a=f.read(); f.close()
  except: return
  if(a[:9]=="connected"): self.say("HPJACK 1")
  elif(a[:9]=="disconnec"): self.say("HPJACK 0")

 def say(self, what):
  print what
# #+"\n";
  sys.stdout.flush()

 def handle_hsb(self, signal, button):
#  print "handle_hsb: "+str(signal)+","+str(button)
  # "phone" is the button on the wired headset
  #if(button=="phone"): self.say("PLAYPAUSE")
  if(button=="phone"): self.say("NEXT")
  elif(button=="next-song"): self.say("NEXT")
  elif(button=="previous-song"): self.say("PREV")
  elif(button=="play-cd"): self.say("PLAYPAUSE")

 def handle_focus(self, signal, button):
  #print "handle_dbus: "+str(signal)+","+str(button)
  if(self.focus==0): self.focus=time.time()
  else:
   dt=time.time()-self.focus; self.focus=0
   if(dt<0.5): self.say("FFWD")
   else: self.say("PLAYPAUSE")

 def __init__(self):
  if(len(sys.argv)!=2): return
  else: self.id=sys.argv[1]
#  self.id="n900"

  from dbus.mainloop.glib import DBusGMainLoop; import dbus
  dbus.mainloop.glib.DBusGMainLoop(set_as_default=True)
  self.sbus = dbus.SystemBus()

  if(self.id=="n900"):
# turns on the current to the headset pin
#   os.system("amixer -qc0 cset iface=MIXER,name='Jack Bias Switch' on")
   dp_hsb_fremantle = '/org/freedesktop/Hal/devices/computer_logicaldev_input_1'
   dp_camfocus_fremantle = '/org/freedesktop/Hal/devices/platform_cam_focus'
   dp_hpjack = '/org/freedesktop/Hal/devices/platform_headphone'
#   dp_bu = '/org/freedesktop/Hal/devices/computer_logicaldev_input'

#   self.sbus.add_signal_receiver(self.handle_dbus, 'Condition','org.freedesktop.Hal.Device', None, dp_bu)
   self.sbus.add_signal_receiver(self.handle_hsb, 'Condition','org.freedesktop.Hal.Device', None, dp_hsb_fremantle)
   self.sbus.add_signal_receiver(self.handle_focus, 'Condition','org.freedesktop.Hal.Device', None, dp_camfocus_fremantle)
#   self.mceRequest = self.sbus.get_object('com.nokia.mce', '/com/nokia/mce/request')
   self.sbus.add_signal_receiver(self.handle_hpjack, 'Condition','org.freedesktop.Hal.Device', None, dp_hpjack)

# https://raw.githubusercontent.com/M4rtinK/modrana/master/modules/device_modules/device_n900.py

 def wbuf(self, a, b):
  c=a.readline(1024)
  self.say("wbuf: a:"+str(a)+", b:"+str(b)+", c:"+str(c)+" ("+str(len(c))+")")
  if(len(c)==0): sys.exit()
  return True

 def main(self):
  if(self.id==""): self.say("use id as arg"); sys.exit()
  else: self.say("id: "+str(self.id))
  gobject.io_add_watch(sys.stdin, glib.IO_IN, self.wbuf)

  self.say("HPJACK 0")
  mainloop = glib.MainLoop(); mainloop.run()

if __name__ == "__main__":
 oremdl = oscp_dbus_listener()
 oremdl.main()
